#pragma once
namespace Themis {

/**
    ꎞt@CB
*/
class CTempFile : private boost::noncopyable {
public:
    CTempFile(const string& strPrefix = string(), const string& strSuffix = L"tmp");
    CTempFile(const CFileName& oBaseDir, const string& strPrefix = string(), const string& strSuffix = L"tmp");
    ~CTempFile();

    //@{ 쐬
    void Create(const vector<uint8_t>& vct);
    void Create(const string& str);
    void CreateByCopy(const CFileName& oFileName);
    void CreateByMove(const CFileName& oFileName);
    //@}

    /// t@C폜Ėɂ(fXgN^Ă΂)
    void Delete();
    /// t@C폜ɖɂ
    void Release();
    /// oDstFileNameɈړRelease();
    void MoveAndRelease(const CFileName& oDstFileName);

    /// t@C̎擾
    const CFileName& GetName() const { return m_oFileName; }

    /// Ô߁B
    const CFileName& GetBaseDir() const { return m_oBaseDir; }

private:
    CFileName   m_oBaseDir;
    CFileName   m_oFileName;
    bool        m_bOwner;
};


/**
    ꎞfBNgB
*/
class CTempDir : private boost::noncopyable {
public:
    CTempDir(const string& strPrefix = string());
    CTempDir(const CFileName& oBaseDir, const string& strPrefix = string());
    ~CTempDir();

    /// 쐬
    void Create();

    /// fBNg폜Ėɂ(fXgN^Ă΂)
    void Delete();
    /// fBNg폜ɖɂ
    void Release();

    /// fBNg̎擾
    const CFileName& GetName() const { return m_oDirName; }

    /// Ô߁B
    const CFileName& GetBaseDir() const { return m_oBaseDir; }

private:
    CFileName   m_oBaseDir;
    CFileName   m_oDirName;
};

}
