#pragma once
#include "tpl/map_vector.h"
namespace Themis {

class CMsgHookPrms;

/**
    EBhẼXibvsB

    ̃EBhEňSnapperLėp鎖\ƂB

    RsypTv
@code

namespace Themis {
    class CWindowSnapper;
}

@endcode@code

    auto_ptr<CWindowSnapper> m_pSnapper;

@endcode@code

#include <Themis/WindowSnapper.h>

@endcode@code

        m_pSnapper.reset(new CWindowSnapper);
        m_pSnapper->SetSnapWorkArea(true);
        m_pSnapper->SetSnapDist(32);

@endcode@code

        } else if (rPrms.GetMsg() == WM_ENTERSIZEMOVE) {
            if (m_pSnapper.get() != NULL) {
                return m_pSnapper->OnEnterSizeMove(rPrms);
            }
            return false;
        } else if (rPrms.GetMsg() == WM_EXITSIZEMOVE) {
            if (m_pSnapper.get() != NULL) {
                return m_pSnapper->OnExitSizeMove(rPrms);
            }
            return false;
        } else if (rPrms.GetMsg() == WM_MOVING) {
            if (m_pSnapper.get() != NULL) {
                return m_pSnapper->OnMoving(rPrms);
            }
            return false;
        }

@endcode

*/
class CWindowSnapper : private boost::noncopyable {
public:
    CWindowSnapper();
    ~CWindowSnapper();

    //@{ [NGAɃXibv邩ǂ
    bool IsSnapWorkArea() const;
    void SetSnapWorkArea(bool b);
    //@}
    //@{ Xibvő勗
    int GetSnapDist() const;
    void SetSnapDist(int n);
    //@}

    //@{ ̃EBhEɃXibvꍇɓo^
    void AddTarget(HWND hWnd);
    void RemoveTarget(HWND hWnd);
    void ClearTarget();
    //@}

    /// WM_ENTERSIZEMOVE ̏
    bool OnEnterSizeMove(CMsgHookPrms& rPrms);
    /// WM_EXITSIZEMOVE ̏
    bool OnExitSizeMove(CMsgHookPrms& rPrms);
    /// WM_MOVING ̏
    bool OnMoving(CMsgHookPrms& rPrms);

    //@{ hbOhbvł̈ړOōsꍇ
    void OnBeginMove(HWND hWnd);
    void OnEndMove(HWND hWnd);
    bool OnMove(HWND hWnd, CRect& rrc);
    //@}

    ///@{ XibvTCY
    void SetWindowRect(HWND hWnd, const CRect& rc);
    void SetClientRect(HWND hWnd, const CRect& rc);
    //@}
private:
    CRect ResizeRect(HWND hWnd, const CRect& rcWindow, const CRect& rc);

private:
    vector<HWND>            m_vctTarget;
    map_vector<HWND, CSize> m_oWindowToCursorList;
    int                     m_nSnapDist;
    bool                    m_bSnapWorkArea;
};

}
