#include "stdafx.h"
#include "CpuId.h"
namespace Themis {

namespace {
    unsigned GetCpuId(unsigned nFlag) {
        unsigned dwCPU = 0;
        _asm {
            pushfd                      //tOWX^Ҕ
            pop     eax                 //tOWX^̓eeax
            mov     ebx, eax
            xor     eax, 00200000h      //bit21𔽓]
            push    eax                 //X^bN
            popfd                       //tOWX^֏
            pushfd                      //tOWX^̓eX^bN
            pop     eax                 //tOWX^̓eeax
            cmp     eax, ebx            //قȂĂcpuid߂
            jz      LNoCpuId
            mov     eax, nFlag          //feature flag
            cpuid
            mov     dwCPU, edx
        LNoCpuId:
        }
        return dwCPU;
    }
}

unsigned CCpuId::Get() {
    static unsigned s_nCpuId = GetCpuId(0x00000001u);
    return s_nCpuId;
}

unsigned CCpuId::GetEx() {
    static unsigned s_nCpuId = GetCpuId(0x80000001u);
    return s_nCpuId;
}

}
