namespace Themis {

namespace PlatformID {
    enum T {
        Win32S,
        Win32Windows, // Windows 95 ȍ~
        Win32NT, // Windows NT ȍ~
        WinCE,
        Unix,
    };
}

/*
class Version : private boost::totally_ordered<Version> {
    int major, minor, build, revision;
public:
    Version();
    Version(const string& version);
    Version(int major, int minor);
    Version(int major, int minor, int build);
    Version(int major, int minor, int build, int revision);

    //bool operator==(const Version& other) const;
    //bool operator<(const Version& other) const;

    int Build { get; }
    int Major { get; }
    int Minor { get; }
    int Revision { get; }
    short MajorRevision { get; }
    short MinorRevision { get; }

    //object Clone();
    //int CompareTo(object version);
    //int CompareTo(Version value);
    //override bool Equals(object obj);
    //bool Equals(Version obj);
    //override int GetHashCode();
    //override string ToString();
    //string ToString(int fieldCount);
};

class OperatingSystem {
    PlatformID platform;
    Version version;
public:
    OperatingSystem(PlatformID platform, Version version)
        : platform(platform), version(version) {}

    PlatformID Platform { get; }
    string ServicePack { get; }
    Version Version { get; }
    string VersionString { get; }

    //object Clone();
    //void GetObjectData(SerializationInfo info, StreamingContext context);
    //override string ToString();
};
*/

/**
 * .NETEnvironmentNXȊB
 */
class Environment {
public:
    /// R}hC̎擾
    static string GetCommandLine();
    /// parseς݂̃R}hC̎擾
    static List<string> GetCommandLineArgs();

    //@{ JgfBNg
    static string GetCurrentDirectory();
    static void SetCurrentDirectory(const string& path);
    //@}

    //static int ExitCode { get; set; }
    //static bool HasShutdownStarted { get; }
    //static string MachineName { get; }

    /// sȕB
    static string GetNewLine() { return L"\r\n"; }

    //static OperatingSystem OSVersion { get; }

    /// vZbT̎擾
    static int GetProcessorCount() {
        SYSTEM_INFO si = {0};
        ::GetSystemInfo(&si);
        return static_cast<int>(si.dwNumberOfProcessors);
    }

    //static string StackTrace { get; }
    //static string SystemDirectory { get; }
    //static int TickCount { get; }
    //static string UserDomainName { get; }
    //static bool UserInteractive { get; }
    //static string UserName { get; }
    //static Version Version { get; }
    //static long WorkingSet { get; }

    //static void Exit(int exitCode);

    /// %ϐ% ̓WJB
    static string ExpandEnvironmentVariables(const string& name);

    //static void FailFast(const string& message);

    //static string GetEnvironmentVariable(const string& variable);
    //static string GetEnvironmentVariable(const string& variable, EnvironmentVariableTarget target);
    //static IDictionary GetEnvironmentVariables();
    //static IDictionary GetEnvironmentVariables(EnvironmentVariableTarget target);
    //static void SetEnvironmentVariable(const string& variable, const string& value);
    //static void SetEnvironmentVariable(const string& variable, const string& value, EnvironmentVariableTarget target);

    //static string[] GetLogicalDrives();

    struct SpecialFolder {
        enum T {
            Desktop,
            Programs,
            Personal,
            MyDocuments,
            Favorites,
            Startup,
            Recent,
            SendTo,
            StartMenu,
            MyMusic,
            DesktopDirectory,
            MyComputer,
            Templates,
            ApplicationData,
            LocalApplicationData,
            InternetCache,
            Cookies,
            History,
            CommonApplicationData,
            System,
            ProgramFiles,
            MyPictures,
            CommonProgramFiles,
        };
    };

    //static string GetFolderPath(SpecialFolder::T folder);
};

}
