#pragma once

class CConfigDialogDrawPage : public CConfigDialogTabBase {
public:
    CConfigDialogDrawPage() : CConfigDialogTabBase(IDD_CFG_DRAW) {}
private:
    CChooseColor m_oChooseColor;
    COLORREF m_rgbBgColor;
    bool HookMsg(CMsgHookPrms& rPrms) {
        if (rPrms.GetMsg() == WM_COMMAND) {
            UpdateCtrl();
            switch (rPrms.GetWPrmLoWord()) {
            case IDC_BUTTON2: // wiF̐ݒ
                {
                    m_oChooseColor.SetOwner(GetDialog().GetHandle());
                    m_oChooseColor.SetDefault(m_rgbBgColor);
                    if (m_oChooseColor.Show()) {
                        m_rgbBgColor = m_oChooseColor.GetResult();
                    }
                }
                break;
            default:
                return false;
            }
            return true;
        } else if (rPrms.GetMsg() == WM_INITDIALOG) {
            // [邿ՁB
            CDialogTooltip* pTip = new CDialogTooltip(GetDialog());
            pTip->Add(IDC_STATIC1, L"\̉摜̐Lk@w肵܂B\r\n"
               L"GDI͒ډʂɑ΂ďksߍĕ`悪xȂA͈͑Ig勾̑쐫Ȃ܂B\r\n"
               L"O͈̕xŏkĂ\邽ߓxԂƂȂA𑽂HAxx߂łB\r\n"
               L"\r\n"
               L"₷ŗDȂ玩O4GDI2ӂ肪Ǝv܂B");
            pTip->Add(IDC_RADIO6, L"jAXglCo[Ȃ");
            pTip->Add(IDC_RADIO7, L"ڍוsBoCL[rbNH\r\nWin98ȑOƑGDI1ƓɂȂ܂B");
            pTip->Add(IDC_RADIO3, L"jAXglCo[̂");
            pTip->Add(IDC_RADIO4, L"oCjÂ肾ǂȂ񂩊ԈĂC@");
            pTip->Add(IDC_RADIO5, L"ʐϕϖ@Ƃωf@Ƃ炵@B\r\n"
                L"ڂ₯CɂȂ̂ŃV[vtB^ӂƍ킹ĎgƂ܂B");
            pTip->Add(IDC_RADIO10, L"3̌ɃV[vśB");
            pTip->Add(IDC_RADIO8, L"Lanczos3B\r\nԒxĈYłB\r\n"
                L"fARACPU3DNow!gꍇ͏̓}VɂȂ܂B");
            pTip->Add(IDC_CHECK21, L"摜̐LkɁAClearTypeۂs܂B\r\n"
                L"tfBXvC̏ꍇA킸Ɍ₷シ邩܂B\r\n"
                L"A\̏ꍇ͌ʂA܂AO3,4GDI2̏ꍇX炩Ȃ߂܂͂ڂȂ܂B");

            pTip->Add(IDC_EDIT31, L"J\́AQ̉摜̊ԊusNZŎw肵܂B");

            pTip->Add(IDC_BUTTON2, L"wiFݒ肵܂B");
            return true;
        } else if (rPrms.GetMsg() == WM_CLOSE) {
            GetDialog().Delete();
            return true;
        } else {
            return false;
        }
    }
    void LoadFromConfig(CConfig& m_oConfig) {
        m_oConfig.NumData(L"DrawMode_") >> CRadiosData(GetDialog(),
            IDC_RADIO6, IDC_RADIO7, IDC_RADIO3, IDC_RADIO4, IDC_RADIO5, IDC_RADIO8, IDC_RADIO10);
        m_oConfig.BoolData(L"ClearType") >> CCheckboxData(GetDialog(), IDC_CHECK21);

        m_oConfig.NumData(L"PaddingCenter") >> CEditboxData(GetDialog(), IDC_EDIT31);

        m_oConfig.ColorData(L"DrawBgColor") >> m_rgbBgColor ;

        UpdateCtrl();
    }
    void SaveToConfig(CConfig& m_oConfig) {
        m_oConfig.NumData(L"DrawMode_") << CRadiosData(GetDialog(),
            IDC_RADIO6, IDC_RADIO7, IDC_RADIO3, IDC_RADIO4, IDC_RADIO5, IDC_RADIO8, IDC_RADIO10);
        m_oConfig.BoolData(L"ClearType") << CCheckboxData(GetDialog(), IDC_CHECK21);

        m_oConfig.NumData(L"PaddingCenter") << CEditboxData(GetDialog(), IDC_EDIT31);

        m_oConfig.ColorData(L"DrawBgColor") << m_rgbBgColor ;
    }
    void UpdateCtrl() {
    }
};
