#pragma once

class CConfigDialogImagePage : public CConfigDialogTabBase {
public:
    CConfigDialogImagePage() : CConfigDialogTabBase(IDD_CFG_IMG) {}
private:
    bool HookMsg(CMsgHookPrms& rPrms) {
        if (rPrms.GetMsg() == WM_COMMAND) {
            UpdateCtrl();
            switch (rPrms.GetWPrmLoWord()) {
            case IDC_EDIT9:
            case IDC_EDIT10:
                GetDialog().Static(IDC_STATIC1).SetText(string::Format(L"(%dMB/)",
                    (GetDialog().Editbox(IDC_EDIT9).GetInt() *
                    GetDialog().Editbox(IDC_EDIT10).GetInt() * 4 + 524288) / 1048576));
                break;
            case IDC_EDIT11:
            case IDC_EDIT32:
                GetDialog().Static(IDC_STATIC2).SetText(string::Format(L"(%dMB/)",
                    (GetDialog().Editbox(IDC_EDIT11).GetInt() *
                    GetDialog().Editbox(IDC_EDIT32).GetInt() * 4 + 524288) / 1048576));
                break;
            default:
                return false;
            }
            return true;
        } else if (rPrms.GetMsg() == WM_INITDIALOG) {
            // [邿ՁB
            CDialogTooltip* pTip = new CDialogTooltip(GetDialog());
            pTip->Add(IDC_CHECK20, L"߂t@C傫߂t@Cǂݍ܂Ȃ悤ɐݒ肵܂B");
            pTip->Add(IDC_EDIT21, L"ǂݍލŒ̃t@CTCYw肵܂B");
            pTip->Add(IDC_EDIT22, L"ǂݍލō̃t@CTCYw肵܂B");

            pTip->Add(IDC_EDIT7, L"uJPEGt@CƂďov̍ۂJPEGt@C̕iw肵܂B(0 ` 100)");
            pTip->Add(IDC_EDIT25, L"PNG̈kxw肵܂B\r\n"
                L"0kA9ōkŁAkقǏɎԂ⃁KvłB\r\n"
                L"-1ɂƃftHgl(6)g܂B");

            pTip->Add(IDC_CHECK10, L"ŒቡƍŒcw肵A菬t@C\Ȃ悤ɂ܂B");
            pTip->Add(IDC_EDIT17, L"ŒTCYw肵܂B( x cj");
            pTip->Add(IDC_EDIT18, L"ŒTCYw肵܂B( x cj");
            pTip->Add(IDC_CHECK11, L"ƏcʁXɂł͂ȂAʐςł̂ݔrs܂B");

            pTip->Add(IDC_CHECK5, L"ȍ~̉摜ǂ݂ăy[W鏈s܂B");
            pTip->Add(IDC_EDIT6, L"\Ƀ󂢂ĂꍇɎgpLbVw肵܂B");
            pTip->Add(IDC_EDIT8, L"󂫃̂Aтオgp銄w肵܂B\r\n"
                L"т𕡐NꍇA󂫃𑽂߂ɎcĂꍇ́A߂̒lݒ肵܂B");
            pTip->Add(IDC_EDIT9, L"LbVZo邽߂̊ƂȂ摜̑傫w肵܂B\r\n"
                L"J͒PɂQ{܂B");
            pTip->Add(IDC_EDIT10, L"LbVZo邽߂̊ƂȂ摜̑傫w肵܂B\r\n"
                L"J͒PɂQ{܂B");
            pTip->Add(IDC_CHECK2, L"LbVւ̐ǂ݂ƓɁAgEk̃f[^쐬ăLbV܂B"
                L"gpʂ{܂Ay[W肪ق̂葁Ȃ悤ȋC܂B\r\n"
                L"ő喇̔{ȏ̃LbVgp\ȏꍇɂ̂ݗLɂȂ܂B\r\n"
                L"ۂɗLɂȂĂ邩ǂ́Auwvo[WvŊmF\łB");
            pTip->Add(IDC_CHECK3, L"ǂ݂Ƃ͕ʂɁAt@Cǂݍݏ񉻁ELbV܂B"
                L"gpʂ{܂Albg[NoRȂǂ̏ꍇɁAy[W肪KɂȂꍇ܂B\r\n"
                L"At@C̓eXVꂽƂoȂ̂ŁAKvΕҏWēǍiftHgłF5L[jgpĂB\r\n"
                L"ő喇̔{ȏ̃LbVgp\ȏꍇɂ̂ݗLɂȂ܂B\r\n"
                L"ۂɗLɂȂĂ邩ǂ́Auwvo[WvŊmF\łB");

            pTip->Add(IDC_CHECK1, L"傫摜́AǂݍݎɏkĂ܂ƂŁA̐ߖEs܂B\r\n"
                L"̉摜͕ێȂ߁A摜̏oȂǂsۂɂ͒ӂĂB\r\n"
                L"܂A摜^Cgo[ɕ\摜̃TCYȂǂ́Ak̉摜ɑ΂lƂȂ܂B");
            pTip->Add(IDC_EDIT11, L"őTCYw肵܂B( x cj");
            pTip->Add(IDC_EDIT32, L"őTCYw肵܂B( x cj");
            pTip->Add(IDC_CHECK4, L"It̏ꍇ́AőTCY͂ݏoȂ悤ɏk܂AȈꍇ͖ʐςőTCYȉɎ܂悤ɂȂ܂B");


            return true;
        } else if (rPrms.GetMsg() == WM_CLOSE) {
            GetDialog().Delete();
            return true;
        } else {
            return false;
        }
    }
    void LoadFromConfig(CConfig& m_oConfig) {
        m_oConfig.BoolData(L"FileSizeLimit") >> CCheckboxData(GetDialog(), IDC_CHECK20);
        m_oConfig.FloatData(L"FileSizeLimitMin") >> CEditboxData(GetDialog(), IDC_EDIT21);
        m_oConfig.FloatData(L"FileSizeLimitMax") >> CEditboxData(GetDialog(), IDC_EDIT22);

        m_oConfig.NumData(L"JpgQuality") >> CEditboxData(GetDialog(), IDC_EDIT7);
        m_oConfig.NumData(L"PngCompressLevel") >> CEditboxData(GetDialog(), IDC_EDIT25);

        m_oConfig.BoolData(L"ImageSizeLimit") >> CCheckboxData(GetDialog(), IDC_CHECK10);
        m_oConfig.FloatData(L"ImageSizeLimitPixel.cx") >> CEditboxData(GetDialog(), IDC_EDIT17);
        m_oConfig.FloatData(L"ImageSizeLimitPixel.cy") >> CEditboxData(GetDialog(), IDC_EDIT18);
        m_oConfig.BoolData(L"ImageSizeLimitCmpArea") >> CCheckboxData(GetDialog(), IDC_CHECK11);

        m_oConfig.BoolData(L"ImageCache") >> CCheckboxData(GetDialog(), IDC_CHECK5);
        m_oConfig.NumData(L"ImageCacheAutoMax") >> CEditboxData(GetDialog(), IDC_EDIT6);
        m_oConfig.NumData(L"ImageCacheAutoLimitRate") >> CEditboxData(GetDialog(), IDC_EDIT8);
        m_oConfig.NumData(L"ImageCacheAutoBaseW") >> CEditboxData(GetDialog(), IDC_EDIT9);
        m_oConfig.NumData(L"ImageCacheAutoBaseH") >> CEditboxData(GetDialog(), IDC_EDIT10);
        m_oConfig.BoolData(L"StretchCaching") >> CCheckboxData(GetDialog(), IDC_CHECK2);
        m_oConfig.BoolData(L"LoaderCaching") >> CCheckboxData(GetDialog(), IDC_CHECK3);

        m_oConfig.BoolData(L"ReduceOnLoad") >> CCheckboxData(GetDialog(), IDC_CHECK1);
        ItoA(m_oConfig.Size(L"ReduceOnLoadSize").cx) >> CEditboxData(GetDialog(), IDC_EDIT11);
        ItoA(m_oConfig.Size(L"ReduceOnLoadSize").cy) >> CEditboxData(GetDialog(), IDC_EDIT32);
        m_oConfig.BoolData(L"ReduceOnLoadBySpace") >> CCheckboxData(GetDialog(), IDC_CHECK4);

        UpdateCtrl();
    }
    void SaveToConfig(CConfig& m_oConfig) {
        m_oConfig.BoolData(L"FileSizeLimit") << CCheckboxData(GetDialog(), IDC_CHECK20);
        m_oConfig.FloatData(L"FileSizeLimitMin") << CEditboxData(GetDialog(), IDC_EDIT21);
        m_oConfig.FloatData(L"FileSizeLimitMax") << CEditboxData(GetDialog(), IDC_EDIT22);

        m_oConfig.NumData(L"JpgQuality") << CEditboxData(GetDialog(), IDC_EDIT7);
        m_oConfig.NumData(L"PngCompressLevel") << CEditboxData(GetDialog(), IDC_EDIT25);

        m_oConfig.BoolData(L"ImageSizeLimit") << CCheckboxData(GetDialog(), IDC_CHECK10);
        m_oConfig.FloatData(L"ImageSizeLimitPixel.cx") << CEditboxData(GetDialog(), IDC_EDIT17);
        m_oConfig.FloatData(L"ImageSizeLimitPixel.cy") << CEditboxData(GetDialog(), IDC_EDIT18);
        m_oConfig.BoolData(L"ImageSizeLimitCmpArea") << CCheckboxData(GetDialog(), IDC_CHECK11);

        m_oConfig.BoolData(L"ImageCache") << CCheckboxData(GetDialog(), IDC_CHECK5);
        m_oConfig.NumData(L"ImageCacheAutoMax") << CEditboxData(GetDialog(), IDC_EDIT6);
        m_oConfig.NumData(L"ImageCacheAutoLimitRate") << CEditboxData(GetDialog(), IDC_EDIT8);
        m_oConfig.NumData(L"ImageCacheAutoBaseW") << CEditboxData(GetDialog(), IDC_EDIT9);
        m_oConfig.NumData(L"ImageCacheAutoBaseH") << CEditboxData(GetDialog(), IDC_EDIT10);
        m_oConfig.BoolData(L"StretchCaching") << CCheckboxData(GetDialog(), IDC_CHECK2);
        m_oConfig.BoolData(L"LoaderCaching") << CCheckboxData(GetDialog(), IDC_CHECK3);

        m_oConfig.BoolData(L"ReduceOnLoad") << CCheckboxData(GetDialog(), IDC_CHECK1);
        m_oConfig.SizeData(L"ReduceOnLoadSize") << CSize(
            GetDialog().Editbox(IDC_EDIT11).GetInt(),
            GetDialog().Editbox(IDC_EDIT32).GetInt());
        m_oConfig.BoolData(L"ReduceOnLoadBySpace") << CCheckboxData(GetDialog(), IDC_CHECK4);
    }
    void UpdateCtrl() {
        CCtrlEnable(GetDialog().Checkbox(IDC_CHECK20).GetCheck())
            << GetDialog().GetCtrl(IDC_EDIT21)
            << GetDialog().GetCtrl(IDC_EDIT22);

        CCtrlEnable(GetDialog().Checkbox(IDC_CHECK10).GetCheck())
            << GetDialog().GetCtrl(IDC_EDIT17)
            << GetDialog().GetCtrl(IDC_EDIT18)
            << GetDialog().GetCtrl(IDC_CHECK11);

        CCtrlEnable(GetDialog().Checkbox(IDC_CHECK5).GetCheck()) // ImageCache
            << GetDialog().GetCtrl(IDC_EDIT6)
            << GetDialog().GetCtrl(IDC_EDIT8)
            << GetDialog().GetCtrl(IDC_EDIT9)
            << GetDialog().GetCtrl(IDC_EDIT10)
            << GetDialog().GetCtrl(IDC_CHECK2);

        CCtrlEnable(GetDialog().Checkbox(IDC_CHECK1).GetCheck()) // ReduceOnLoad
            << GetDialog().GetCtrl(IDC_EDIT11)
            << GetDialog().GetCtrl(IDC_EDIT32)
            << GetDialog().GetCtrl(IDC_CHECK4);
    }
};

