#pragma once

class CConfigDialogWholePage : public CConfigDialogTabBase {
public:
    CConfigDialogWholePage() : CConfigDialogTabBase(IDD_CFG_WHOLE) {}
private:
    bool HookMsg(CMsgHookPrms& rPrms) {
        if (rPrms.GetMsg() == WM_COMMAND) {
            UpdateCtrl();
            switch (rPrms.GetWPrmLoWord()) {
            case IDC_BUTTON1:
                ChooseDir(IDC_EDIT1);
                break;
            case IDC_BUTTON3:
                ChooseDir(IDC_EDIT11);
                break;
            default:
                return false;
            }
            return true;
        } else if (rPrms.GetMsg() == WM_INITDIALOG) {
            // [邿ՁB
            CDialogTooltip* pTip = new CDialogTooltip(GetDialog());
            pTip->Add(IDC_CHECK7, L"ǎ摜fBXvC̃TCYɍ킹ĊgEk܂B");
            pTip->Add(IDC_CHECK8, L"̐ݒ肪ȈꍇAǎt@CŎw肵t@CŕǎۑtH_ɕۑ܂B\r\n"
                L"It̏ꍇAIWĩt@C̊gqbmpɕύXt@CŕǎۑtH_ɕۑ܂B");
            pTip->Add(IDC_EDIT12, L"ꂷꍇ̃t@Cw肵܂B");
            pTip->Add(IDC_EDIT11, L"ǎp摜ۑtH_w肵܂B");

            pTip->Add(IDC_CHECK9, L"lbg[NXVɃvLVT[o[oRĐڑ邩ǂB");
            pTip->Add(IDC_EDIT13, L"vLVT[o[B\r\n"
                L"u:v؂Ń|[g̎w\łB");
            pTip->Add(IDC_CHECK1, L"lbg[NXVɎst@C̃obNAbv쐬邩ǂB");
            pTip->Add(IDC_EDIT20, L"obNAbvꍇ́AÂt@Čw肵܂B");

            pTip->Add(IDC_EDIT1, L"ubN}[Nt@CۑtH_w肵܂B");
            pTip->Add(IDC_BUTTON1, L"tH_I܂B");
            pTip->Add(IDC_EDIT3, L"f[^ۑtH_w肵܂B");
            pTip->Add(IDC_BUTTON2, L"tH_I܂B");
            pTip->Add(IDC_EDIT28, L"f[^ۑ錏w肵܂B10OオƎv܂B0Ȃ痚̕ۑs܂B");
            return true;
        } else if (rPrms.GetMsg() == WM_CLOSE) {
            GetDialog().Delete();
            return true;
        } else {
            return false;
        }
    }
    void ChooseDir(int nId) {
        CChooseDir oChooseDir;
        oChooseDir.SetOwner(GetDialog().GetHandle());
        oChooseDir.SetDefault(CFileNameModuleDir(GetDialog().Editbox(nId).GetText()));
        if (oChooseDir.Show()) {
            GetDialog().Editbox(nId).SetText(oChooseDir.GetResult().Get());
        }
    }
    void LoadFromConfig(CConfig& m_oConfig) {
        m_oConfig.BoolData(L"WallpaperResize") >> CCheckboxData(GetDialog(), IDC_CHECK7);
        m_oConfig.BoolData(L"WallpaperUnifyFile") >> CCheckboxData(GetDialog(), IDC_CHECK8);
        m_oConfig.FileData(L"WallpaperUnifyFileName") >> CEditboxData(GetDialog(), IDC_EDIT12);
        m_oConfig.FileData(L"WallpaperDir") >> CEditboxData(GetDialog(), IDC_EDIT11);

        m_oConfig.BoolData(L"HttpProxy") >> CCheckboxData(GetDialog(), IDC_CHECK9);
        m_oConfig.StrData(L"HttpProxyServer") >> CEditboxData(GetDialog(), IDC_EDIT13);
        m_oConfig.BoolData(L"HttpBackup") >> CCheckboxData(GetDialog(), IDC_CHECK1);
        m_oConfig.StrData(L"HttpBackupCount") >> CEditboxData(GetDialog(), IDC_EDIT20);

        m_oConfig.FileData(L"BookmarkDir") >> CEditboxData(GetDialog(), IDC_EDIT1);
        m_oConfig.FileData(L"HistoryDir") >> CEditboxData(GetDialog(), IDC_EDIT3);
        m_oConfig.NumData(L"HistoryMax") >> CEditboxData(GetDialog(), IDC_EDIT28);

        UpdateCtrl();
    }
    void SaveToConfig(CConfig& m_oConfig) {
        m_oConfig.BoolData(L"WallpaperResize") << CCheckboxData(GetDialog(), IDC_CHECK7);
        m_oConfig.BoolData(L"WallpaperUnifyFile") << CCheckboxData(GetDialog(), IDC_CHECK8);
        m_oConfig.FileData(L"WallpaperUnifyFileName") << CEditboxData(GetDialog(), IDC_EDIT12);
        m_oConfig.FileData(L"WallpaperDir") << CEditboxData(GetDialog(), IDC_EDIT11);

        m_oConfig.BoolData(L"HttpProxy") << CCheckboxData(GetDialog(), IDC_CHECK9);
        m_oConfig.StrData(L"HttpProxyServer") << CEditboxData(GetDialog(), IDC_EDIT13);
        m_oConfig.BoolData(L"HttpBackup") << CCheckboxData(GetDialog(), IDC_CHECK1);
        m_oConfig.StrData(L"HttpBackupCount") << CEditboxData(GetDialog(), IDC_EDIT20);

        m_oConfig.FileData(L"BookmarkDir") << CEditboxData(GetDialog(), IDC_EDIT1);
        m_oConfig.FileData(L"HistoryDir") << CEditboxData(GetDialog(), IDC_EDIT3);
        m_oConfig.NumData(L"HistoryMax") << CEditboxData(GetDialog(), IDC_EDIT28);
    }
    void UpdateCtrl() {
        // ǎ
        CCtrlEnable(GetDialog().Checkbox(IDC_CHECK8).GetCheck())
            << GetDialog().GetCtrl(IDC_EDIT12);
        // proxy
        CCtrlEnable(GetDialog().Checkbox(IDC_CHECK9).GetCheck())
            << GetDialog().GetCtrl(IDC_EDIT13);
        // ˂Ƃ킭΂
        CCtrlEnable(GetDialog().Checkbox(IDC_CHECK1).GetCheck())
            << GetDialog().GetCtrl(IDC_EDIT20);
    }
};
