#pragma once
#include <Themis/Window.h>
namespace Themis {
class CLocalExclusion;
}

/**
    g勾B
*/
class CMagnifierWindow : private IMsgHooker {
public:
    class IOwner {
    public:
        /**
        void OnPaint(PAINTSTRUCT& ps, const CSize& szDst, const CPoint& ptSrcCenter);

            szDst           g勾̕`̈̑傫
            ptSrcCenter     ẽNCAgWł̒SWiJ[\ʒuj
        */
        virtual void OnPaint(PAINTSTRUCT& ps, const CSize& szDst, const CPoint& ptSrcCenter) = 0;
    };

    CMagnifierWindow(CWindow& rWindow, IOwner& pOwner);
    ~CMagnifierWindow();

    void SetSize(const CSize& sz);
    CSize GetSize() const;

    void SetShape(int nShape);
    int GetShape() const;

    void Show();
    void Hide();

private:
    bool HookMsg(CMsgHookPrms& rPrms);

private:
    CWindow& m_rWindow;
    IOwner& m_pOwner;
    CWindow                     m_oMagnifierWindow;
    CSize                       m_szMagnifier;
    CPoint                      m_ptCursor;
    auto_ptr<CLocalExclusion>   m_pExclusion;
    int                         m_nShape;
    boost::mutex mutex;
};

