#pragma once

static inline string GetValidSuffix(const string& strSuffix) {
    string str = strSuffix;
    while (0 < str.GetLength() && str[0] == L' ') {
        str = str.Remove(0, 1);
    }
    while (1 < str.GetLength() && str[0] == L'.') {
        str = str.Remove(0, 1);
    }
    while (2 < str.GetLength() && str[0] == L'*' && str[1] == L'.') {
        str = str.Remove(0, 2);
    }
    while (0 < str.GetLength() && str[str.GetLength() - 1] == L' ') {
        str = str.Remove(str.GetLength() - 1, 1);
    }
    // 󔒂Ƃ.Ƃ*ƂĂG[Ȃ̂Ł~
    for (int i = 0, n = str.GetLength(); i < n; i++) {
        if (str[i] == L' ' || str[i] == L'.' || str[i] == L'*' ||
            str[i] == L'?' || str[i] == L':' || str[i] == L'<' ||
            str[i] == L'>' || str[i] == L'|' || str[i] == L'\\' ||
            str[i] == L'/' || str[i] == L'"' || str[i] == L';') {
            throw RuntimeException(strSuffix + L" ͕sȊgqۂł");
        }
    }
    return str;
}

/// TtBbNXXgListBoxB
class SuffixListData : public CDataObjectBase<SuffixListData, string> {
public:
    inline SuffixListData(CWindow& dialog, int ctrlID) : ctrl(dialog.GetCtrl(ctrlID)) {}
    inline void Set(TValueParam t) {
        ctrl.Clear();
        ctrl.Add(t.Split(Array(L';'), StringSplitOptions::RemoveEmptyEntries));
    }
    inline TValue Get() const {
        return string::Join(L";", ctrl.GetAll());
    }
private:
    CListbox ctrl;
};
