#pragma once
#include "Archiver.h"
namespace Themis {

/**
    UnZip32.dllpďɃt@C߂̃NXB
*/
class CUnZipArchiver: public IArchiver {
public:
    CUnZipArchiver();
    ~CUnZipArchiver();

    void ConfigDialog(HWND hWnd);

private:
    virtual vector<string> InnerGetSupportedSuffixes() const;
    virtual bool InnerOpen(vector<SFile>& rList);
    virtual void InnerExtractFile(int nFileIndex, const CFileName& oDirName);
    virtual void InnerLoadFile(int nFileIndex, vector<uint8_t>& vctData);
    virtual EType InnerGetType() const { return eTypeLoadable; }
};

typedef DefaultFactory<CUnZipArchiver, IArchiver>  CUnZipArchiverFactory;

}
