/** @file
 * fobO\B
 *
 * 񂪂炩ĂƂƂɁB
 *
 * @author aki.
 */
#pragma once
#include "MsgHook.h"
namespace Themis {

class CWindow;
class CPlane;
class CFont;

/**
    ̓rPlane̒g\ƂɎgNXB

    {IɎĝăR[hp̂ɊgƂ͂قƂǃiVB

    RsypTv
@code

        static CImageWindow oWindow(L"ł΂");
        oWindow.DrawImage(m_oPlane);

        CImageWindow::Get().DrawImage(m_oPlane);

@endcode
*/
class CImageWindow: private IMsgHooker {
public:
    static CImageWindow& Get();

    CImageWindow(const string& strWindowTitle = L"摜\");
    ~CImageWindow();

    /// 摜`[
    void DrawImage(const CPlane& rSrcPlane, const CRect& rc = CRect(CSize::GetLarge()));

    /// 
    void Close();

private:
    /// bZ[W̏
    bool HookMsg(CMsgHookPrms& rPrms);

private:
    auto_ptr<CWindow> m_pWindow;
    auto_ptr<CPlane> m_pPlane;
    boost::mutex mutex;
};


/**
    fobOpAEgvbgEBhENXB

    A^CɕϐȂ񂩂̕ωƂɁB

    RsypTv
@code

        static COutputWindow oWindow(L"ł΂");
        oWindow.Out(0, string::Format(L"%d", n));

        COutputWindow::Get().Out(0, string::Format(L"%d", n));

@endcode
*/
class COutputWindow: private IMsgHooker {
public:
    static COutputWindow& Get();

    COutputWindow(const string& strWindowTitle = L"\");
    ~COutputWindow();

    /// o
    void Out(int nLine, const string& str);

    /// 
    void Close();

private:
    /// bZ[W̏
    bool HookMsg(CMsgHookPrms& rPrms);

private:
    auto_ptr<CWindow> m_pWindow;
    auto_ptr<CPlane> m_pPlane;
    auto_ptr<CFont> m_pFont;
};


/**
    O\B

    V񂪉̕ɒǉĂāA̕ɌÂ񂪎ćB
    ω̂ł͂ȂAs̗IȌꍇɌĂB

    ̂XN[o[œȂc

    RsypTv
@code

        static CLogWindow oWindow(L"ł΂");
        oWindow.Out(string::Format(L"%d", n));

        CLogWindow::Get().Out(string::Format(L"%d", n));

@endcode
*/
class CLogWindow: private IMsgHooker {
public:
    static CLogWindow& Get();

    CLogWindow(const string& strWindowTitlee = L"O\");
    ~CLogWindow();

    /// ǉ
    void Out(const string& str);
    /// O
    void Clear();

    /// TCY̐ݒ
    void SetClientSize(const CSize& sz);
    /// 
    void Close();

private:
    /// bZ[W̏
    bool HookMsg(CMsgHookPrms& rPrms);

private:
    auto_ptr<CWindow> m_pWindow;
};

}
