#pragma once
namespace Themis {

/**
    ʉ𑜓xύXƂǗB

    Iɖ߂ȂƁAɂ͖߂Ȃ(ꍇ)̂Œӂ邱ƁB
*/
class CDisplay : private boost::noncopyable {
public:
    /// ʂ̉𑜓xƂ̏
    struct SVideo {
        CSize   oSize;              ///< width / height
        int     nBpp;               ///< bits per pixel
        int     nRRate;             ///< refresh rate

        /// wȂ̃ftHgl`
        BOOST_STATIC_CONSTANT(int, nDefault = -1);

        SVideo() : oSize(nDefault, nDefault), nBpp(nDefault), nRRate(nDefault) {}
        SVideo(const DEVMODE& dm) : oSize(dm.dmPelsWidth, dm.dmPelsHeight),
            nBpp(dm.dmBitsPerPel), nRRate(dm.dmDisplayFrequency) {}
        bool operator == (const SVideo& v) const;
        bool operator != (const SVideo& v) const { return !(*this == v); }
        bool operator == (const DEVMODE& dm) const;
        bool operator != (const DEVMODE& dm) const { return !(*this == dm); }
    };
    /// T|[gĂ郂[hȂ̂H
    static bool IsSupportedMode(const SVideo& rv);
    /// fBXvC[hύX
    static void Set(const SVideo& rv);
    /// fBXvC[hύX
    static void SetTmp(const SVideo& rv);
    /// SetTmp()ŕύXfBXvC[hɖ߂B߂l͏ǂB
    static bool Restore();
    /// s̃fBXvC̏Ԃ擾
    static SVideo GetCurrentMode();
    /// wCfbNX̃rfI[h擾
    static bool GetMode(SVideo* pv, int nIndex);
    /// [h̍v擾
    static int GetModeSum();

private:
    /// vrfI[h̃CfbNX擾(s-1)
    static int FindModeIndex(const SVideo& rv);

    /// fBXvC[hύXꂽtrue
    static bool changed;
};

}
