#pragma once
namespace Themis {

/**
    B

    Q[pƂƂŁAݒ荀ڂ͓KɍiĒ񋟁B

    RsypTv
@code

        //̈ĺASăRXgN^ŗ^ftHgl
        CFontStyle fs;
        fs.SetFace(L"");
        fs.SetHeight(20);
        fs.SetWeight(CFontStyle::eWeightNormal);
        fs.SetColor(RGB(0xff, 0xff, 0xff));
        fs.SetItalic(false);
        fs.SetUnderLine(false);
        fs.SetStrikeOut(false);
        fs.SetShadowType(1);
        fs.SetShadowColor(RGB(0x00, 0x00, 0x00));
        fs.SetShadowGap(1);
        fs.SetBg(false);
        fs.SetBgColor(RGB(0x00, 0x00, 0x00));
        fs.SetAntiAlias(false);
        fs.SetLineGap(0);
        fs.SetPadding(2, 1, 2, 1);

@endcode

    wiFƂACLR_INVALIDgĂ̂Ȃ̂ǁA
    RtBO_CAO̎ƂlƁA
    Ƃ͕ʂɃtO֗ۂĈŁBB


               [Pad.T]
    [Pad.L] ***  *** [Pad.R]
              [LineGap]
    [Pad.L] ***  *** [Pad.R]
               [Pad.B]
*/
class CFontStyle {
public:
    CFontStyle();
    CFontStyle(const LOGFONT& lf);
    ~CFontStyle();
 // CFontStyle(const CFontStyle& r);
 // CFontStyle& operator=(const CFontStyle& r);
 // oPɑ邾̂ăRpCĂ񂾂ˁcH

    enum EWeight {
        eWeightExtraLight = FW_THIN,
        eWeightLight = FW_LIGHT,
        eWeightNormal = FW_MEDIUM,    //FW_NORMAL?
        eWeightBold = FW_BOLD,
        eWeightExtraBold = FW_HEAVY,
    };

    //@{ tHg
    const string& GetFace() const { return m_strFace; }
    void SetFace(const string& strFaceName) { m_strFace = strFaceName; }
    //@}
    //@{ 傫
    int GetHeight() const { return m_nHeight; }
    void SetHeight(int n) { m_nHeight = n; }
    //@}
    //@{ 
    int GetWeight() const { return m_nWeight; }
    void SetWeight(EWeight n) { m_nWeight = n; }
    //@}
    //@{ F̎擾
    COLORREF GetColor() const { return m_rgbColor; }
    void SetColor(COLORREF rgb) { m_rgbColor = rgb; }
    //@}
    //@{ C^bN
    bool IsItalic() const { return IsFlag(eFlagItalic); }
    void SetItalic(bool b) { SetFlag(eFlagItalic, b); }
    //@}
    //@{ A_[C
    bool IsUnderLine() const { return IsFlag(eFlagUnderLine); }
    void SetUnderLine(bool b) { SetFlag(eFlagUnderLine, b); }
    //@}
    //@{ ł
    bool IsStrikeOut() const { return IsFlag(eFlagStrikeOut); }
    void SetStrikeOut(bool b) { SetFlag(eFlagStrikeOut, b); }
    //@}
    //@{ Type0:e, 1:e, 2:BGap͂ǂꂾ炷BP`QǂB
    int GetShadowType() const { return m_nShadowType; }
    void SetShadowType(int n) { m_nShadowType = n; }
    COLORREF GetShadowColor() const { return m_rgbShadow; }
    void SetShadowColor(COLORREF rgb) { m_rgbShadow = rgb; }
    int GetShadowGap() const { return m_nShadowGap; }
    void SetShadowGap(int n) { m_nShadowGap = n; }
    //@}
    //@{ wi
    bool IsBg() const { return IsFlag(eFlagBg); }
    void SetBg(bool b) { SetFlag(eFlagBg, b); }
    void SetBgColor(COLORREF rgb) { m_rgbBg = rgb; }
    COLORREF GetBgColor() const { return m_rgbBg; }
    //@}
    //@{ 񂿂
    bool IsAntiAlias() const { return IsFlag(eFlagAntiAlias); }
    void SetAntiAlias(bool b) { SetFlag(eFlagAntiAlias, b); }
    //@}
    //@{ sԁBmargin-bottom݂ȊH
    int GetLineGap() const { return m_nLineGap; }
    void SetLineGap(int n) { m_nLineGap = n; }
    //@}
    //@{ wiFƕƂ̌
    const CRect& GetPadding() const { return m_rcPadding; }
    void SetPadding(const CRect& rc) { m_rcPadding = rc; }
    void SetPadding(int l, int t, int r, int b) { m_rcPadding.left = l; m_rcPadding.top = t; m_rcPadding.right = r; m_rcPadding.bottom = b; }
    //@}

    //@{ ֕ۑE񂩂畜A
    string SaveToStr();
    void LoadFromStr(const string& str);
    //@}

private:
    friend class CFont;
    /// LOGFONT\̂쐬Alݒ肷
    LOGFONT GetLogFont() const;

    inline bool IsFlag(int n) const { return (m_nFlags & n) != 0; }
    inline void SetFlag(int n, bool b) {
        if (b) {
            m_nFlags |= n;
        } else {
            m_nFlags &= ~n;
        }
    }

private:
    int         m_nHeight;
    int         m_nWeight;
    COLORREF    m_rgbColor;
    enum {
        eFlagItalic = 1,
        eFlagUnderLine = 1 << 1,
        eFlagStrikeOut = 1 << 2,
        eFlagAntiAlias = 1 << 3,
        eFlagBg = 1 << 4,
    };
    int         m_nFlags;
     // bool        m_bItalic;
     // bool        m_bUnderLine;
     // bool        m_bStrikeOut;
     // bool        m_bAntiAlias;
     // bool        m_bBg;
    int         m_nShadowType;
    int         m_nShadowGap;
    COLORREF    m_rgbShadow;
    COLORREF    m_rgbBg;
    int         m_nLineGap;
    CRect       m_rcPadding;
    string      m_strFace;
};

}
