#pragma once
namespace Themis {

/// Pgetter𐶐}N
#define Themis_PropertyGet(type, name, var) \
    boost::call_traits<type>::value_type Get##name() const { return var; }
        // const_referenceH

/// Psetter𐶐}N
#define Themis_PropertySet(type, name, var) \
    void Set##name(boost::call_traits<type>::param_type p) { var = p; }

/// Pgetter/setter𐶐}N
#define Themis_PropertyGetSet(type, name, var) \
    Themis_PropertyGet(type, name, var) \
    Themis_PropertySet(type, name, var)

/// Pgetter𐶐}N(bool)
#define Themis_PropertyGetBool(name, var) \
    bool Is##name() const { return var; }

/// Pgetter/setter𐶐}N
#define Themis_PropertyGetSetBool(name, var) \
    Themis_PropertyGetBool(name, var) \
    Themis_PropertySet(bool, name, var)

}
