#pragma once
#include "tpl/smart_ptr_vector.h"
#include "Windows/ResourceDialogBase.h"
#include "WndCtrl.h"
namespace Themis {

class CTabCtrl;

/**
    e^uy[WȃIuWFNg

    ʏ͒ڎgKvB
    JX^}CYꍇ́cCTabCtrlƍ蒼C邪Ô߁B _no

    HookMsg()́AI[o[Chꍇ̃NX̂ĂяoׂB
*/
class CTabPage : private CResourceDialogBase {
public:
    CTabPage(int nResourceId);
    virtual ~CTabPage();
    virtual void CreatePage(Themis::IMsgHooker* pHooker, HWND hParent);
    virtual void ClosePage();
    virtual void ShowPage();
    virtual void HidePage();
    virtual CSize GetPageSize();
    virtual void SetPagePos(const CPoint& pt);
    CWindow& GetDialog() { return CResourceDialogBase::GetDialog(); }

protected:
    virtual bool HookMsg(CMsgHookPrms& rPrms);

    /// ԂƂModifiedMarkt
    void SetTabModifiedMark(bool bModified, const string& strSuffix = L" *");
    /// ԂƂ̎擾
    CTabCtrl& GetParentTabCtrl() const { return *m_pParentTabCtrl; }

private:
    friend class CTabCtrl;
    CTabCtrl*   m_pParentTabCtrl;
};



/**
    ^uRg[B

    _CAOClose()Oӂł̃IuWFNg͍폜ׂB

    ^uRg[́AWS_CLIPSIBLINGS KvB

    ^uy[WɎg_CAO\[X́AuX^CFqvƁuRg[FTruevYꂸɁB

    RsypTv
@code

namespace Themis {
    class CTabCtrl;
}

@endcode@code

    auto_ptr<CTabCtrl>  m_pTabCtrl;

@endcode@code

#include <Themis/TabCtrl.h>

@endcode@code

    m_pTabCtrl.reset(new CTabCtrl(GetDialog(), IDC_TAB1));
    m_pTabCtrl->AddPage(L"", new CHogeTabPage);

@endcode@code

    m_pTabCtrl.reset();

@endcode

*/
class CTabCtrl : public CCtrl, private IMsgHooker {
public:
    /**
        CTabCtrlFXʒm󂯎邽߂̃C^[tF[XB
    */
    class IOwner {
    public:
        virtual ~IOwner() {}
        /// e^uy[W\ƂɌĂ΂
        virtual void OnShowTabPage(CTabCtrl& rTabCtrl, int nPage) = 0;
        /// e^uy[W̃bZ[W
        virtual bool HookMsgTabPages(CTabCtrl& rTabCtrl, int nPage, CMsgHookPrms& rPrms) = 0;
    };

    CTabCtrl(CWindow& rParent, int nCtrlId);
    CTabCtrl(IOwner& rOwner, CWindow& rParent, int nCtrlId);
    ~CTabCtrl();

    /// ny[Wڂ\
    void SetPage(int n);
    /// ݕ\Ăy[Wԍ擾
    int GetPage() const { return m_nNowPage; }

    /// y[WSč폜
    void ClearPages();
    /// wy[W폜
    void ClearPage(int n);

    //@{ y[Wǉ
    void AddPage(const string& strTabCaption, int nResourceId) {
        InsertPage(GetPageCount(), strTabCaption, nResourceId);
    }
    void AddPage(const string& strTabCaption, const std::tr1::shared_ptr<CTabPage>& pPage) {
        InsertPage(GetPageCount(), strTabCaption, pPage);
    }
    /// std::tr1::shared_ptrexplicitʓ|Ȃ̂ŁBB
    void AddPage(const string& strTabCaption, CTabPage* pPage) {
        InsertPage(GetPageCount(), strTabCaption, std::tr1::shared_ptr<CTabPage>(pPage));
    }
    //@}
    //@{ y[W}
    void InsertPage(int n, const string& strTabCaption, int nResourceId) {
        InsertPage(n, strTabCaption, std::tr1::shared_ptr<CTabPage>(new CTabPage(nResourceId)));
    }
    void InsertPage(int n, const string& strTabCaption, const std::tr1::shared_ptr<CTabPage>& pPage);
    //@}

    //@{ y[W̃^Cg擾Eݒ
    string GetText(int n) const;
    void SetText(int n, const string& strTabCaption);
    //@}
    /// bModifiedtrueȂstrSuffix(L" *")t
    void SetTextModifiedMark(int n, bool bModified, const string& strSuffix = L" *");

    /// y[W擾
    int GetPageCount() const { return static_cast<int>(m_vctPages.size()); }
    /// y[WIuWFNg̎擾
    CTabPage& GetPage(int i) const { return *m_vctPages[i]; }
    /// y[W̃EBhEIuWFNg擾
    CWindow& GetPageWindow(int i) const { return GetPage(i).GetDialog(); }

    /// SẴy[W܂ŏTCY̎擾
    CSize GetMinSize();
    /// ʒuƂZbg
    void Reset() { HidePage(m_nNowPage); ShowPage(m_nNowPage); }

    /// w^uy[W̃y[W擾B-1B
    int FindPage(CTabPage& rTabPage);

private:
    bool HookMsg(CMsgHookPrms& rPrms);
    void ShowPage(int n);
    void HidePage(int n);

private:
    IOwner*                     m_pOwner;
    HWND                        m_hWndParent;
    smart_ptr_vector<CTabPage>  m_vctPages;
    int                         m_nNowPage;
};

}
