#pragma once
#include "ImplData.h"
namespace Themis {

struct SVolumeControllerData;

/**
    {[ύXB
*/
class CVolumeController {
    ImplData<SVolumeControllerData> data;
public:
    CVolumeController();
    ~CVolumeController();

    enum EDevice {
        eDeviceMaster,  // }X^[
        eDeviceWave,    // WAVE
        eDeviceMidi,    // MIDIo
        eDeviceCd,      // CDĐ
        eDeviceLine,    // CC
        c_nDeviceCount,
    };

    //@{ {[l̎擾Eݒ
    int GetVolume(EDevice eDevice) const;
    void SetVolume(EDevice eDevice, int nPercent);
    //@}

private:
    bool Open();
    void Close();
};

}
