#include "stdafx.h"
#include "AppWindowMenu.h"
#include "MenuID.h"

AppWindowMenu::AppWindowMenu() {
    int currentCategory = 0 - 1;

    #define CATEGORY(_category, _accKey) \
        currentCategory++; \
        menuStrip.GetItems().Add(new ToolStripMenuItem(_category _accKey));

    #define ITEM(_id, _category, _text, _textKey, _key) \
        static_cast<ToolStripMenuItem&>(menuStrip.GetItems()[currentCategory]) \
            .GetDropDownItems().Add(new ToolStripTextItem(GV_MENUID(_id), _text _textKey));

    #define SEPARATOR() \
        static_cast<ToolStripMenuItem&>(menuStrip.GetItems()[currentCategory]) \
            .GetDropDownItems().Add(new ToolStripSeparator());

    #include "MenuData.h"
    #undef SEPARATOR
    #undef ITEM
    #undef CATEGORY
}

AppWindowMenu::~AppWindowMenu() {
}
