#pragma once
#include <Themis/TabCtrl.h>
#include <Themis/Config.h>
#include <Themis/Spi.h>


/// ݒ_CAO
class CConfigDialog : public CResourceDialogBase, CTabCtrl::IOwner {
public:
    CConfigDialog(CConfig& rConfig, CSpi& r, int nDefaultPage);
    ~CConfigDialog();

private:
    bool HookMsg(CMsgHookPrms& rPrms);
    void OnShowTabPage(CTabCtrl& rTabCtrl, int nPage);
    bool HookMsgTabPages(CTabCtrl& rTabCtrl, int nPage, CMsgHookPrms& rPrms);

private:
    CConfig&            m_oConfig;
    CSpi&               m_rSpi;
    const int           m_nDefaultPage;
    auto_ptr<CTabCtrl>  m_pTabCtrl;
};

