#pragma once

class CConfigDialogExternPage  : public CConfigDialogTabBase {
public:
    CConfigDialogExternPage() : CConfigDialogTabBase(IDD_CFG_EXTERN) {}
private:
    int m_nMenuCtrlId;
    bool HookMsg(CMsgHookPrms& rPrms) {
        if (rPrms.GetMsg() == WM_COMMAND) {
            switch (rPrms.GetWPrmLoWord()) {
            case IDC_BUTTON1: ChooseFile(IDC_EDIT1); break;
            case IDC_BUTTON4: ChooseFile(IDC_EDIT4); break;
            case IDC_BUTTON7: ChooseFile(IDC_EDIT7); break;
            case IDC_BUTTON2: m_nMenuCtrlId = IDC_EDIT2; GetDialog().ShowPopupMenu(IDR_EPARGMENU); break;
            case IDC_BUTTON5: m_nMenuCtrlId = IDC_EDIT5; GetDialog().ShowPopupMenu(IDR_EPARGMENU); break;
            case IDC_BUTTON8: m_nMenuCtrlId = IDC_EDIT8; GetDialog().ShowPopupMenu(IDR_EPARGMENU); break;
            case IDC_BUTTON3: m_nMenuCtrlId = IDC_EDIT3; GetDialog().ShowPopupMenu(IDR_EPPWDMENU); break;
            case IDC_BUTTON6: m_nMenuCtrlId = IDC_EDIT6; GetDialog().ShowPopupMenu(IDR_EPPWDMENU); break;
            case IDC_BUTTON9: m_nMenuCtrlId = IDC_EDIT9; GetDialog().ShowPopupMenu(IDR_EPPWDMENU); break;
            case ID__40287: case ID__40288: case ID__40289:
            case ID_MENUITEM40312: case ID_MENUITEM40313:
                {
                    vector<string> vct = CResMenu(IDR_EPARGMENU).GetText(rPrms.GetWPrmLoWord()).Split(Array<string>(L"\t"));
                    if (vct.size() == 2) {
                        GetDialog().Editbox(m_nMenuCtrlId).SetFocus();
                        GetDialog().Editbox(m_nMenuCtrlId).InsertText(vct[0]);
                    }
                }
                break;
            case ID__40291:
                {
                    vector<string> vct = CResMenu(IDR_EPPWDMENU).GetText(rPrms.GetWPrmLoWord()).Split(Array<string>(L"\t"));
                    if (vct.size() == 2) {
                        GetDialog().Editbox(m_nMenuCtrlId).SetFocus();
                        GetDialog().Editbox(m_nMenuCtrlId).InsertText(vct[0]);
                    }
                }
                break;
            default:
                return false;
            }
            return true;
        } else if (rPrms.GetMsg() == WM_INITDIALOG) {
            // [邿ՁB
            CDialogTooltip* pTip = new CDialogTooltip(GetDialog());
            pTip->Add(IDC_EDIT1, L"st@Cw肵܂");
            pTip->Add(IDC_EDIT4, L"st@Cw肵܂");
            pTip->Add(IDC_EDIT7, L"st@Cw肵܂");
            pTip->Add(IDC_EDIT2, L"st@Cɓnw肵܂");
            pTip->Add(IDC_EDIT5, L"st@Cɓnw肵܂");
            pTip->Add(IDC_EDIT8, L"st@Cɓnw肵܂");
            pTip->Add(IDC_EDIT3, L"s̍ƃtH_w肵܂");
            pTip->Add(IDC_EDIT6, L"s̍ƃtH_w肵܂");
            pTip->Add(IDC_EDIT9, L"s̍ƃtH_w肵܂");
            pTip->Add(IDC_BUTTON1, L"st@CI܂");
            pTip->Add(IDC_BUTTON4, L"st@CI܂");
            pTip->Add(IDC_BUTTON7, L"st@CI܂");
            pTip->Add(IDC_BUTTON2, L"ɓϐ}܂");
            pTip->Add(IDC_BUTTON5, L"ɓϐ}܂");
            pTip->Add(IDC_BUTTON8, L"ɓϐ}܂");
            pTip->Add(IDC_BUTTON3, L"ƃtH_ɓϐ}܂");
            pTip->Add(IDC_BUTTON6, L"ƃtH_ɓϐ}܂");
            pTip->Add(IDC_BUTTON9, L"ƃtH_ɓϐ}܂");
            return true;
        } else if (rPrms.GetMsg() == WM_CLOSE) {
            GetDialog().Delete();
            return true;
        } else {
            return false;
        }
    }
    void ChooseFile(int nId) {
        CChooseFile m_oChooseFile;
        m_oChooseFile.SetOwner(GetDialog().GetHandle());
        m_oChooseFile.SetTitle(L"t@CI_CAO");
        m_oChooseFile.ClearNameFilter();
        m_oChooseFile.AddNameFilter(L"Executable File", L"*.COM;*.EXE;*.BAT;*.CMD;*.VBS;*.VBE;*.JS;*.JSE;*.WSF;*.WSH");
        m_oChooseFile.AddNameFilter(L"All Files", L"*.*");
        m_oChooseFile.SetCurrentDir(CFileName(CFileNameModuleDir(GetDialog().Editbox(nId).GetText()).GetDir()));
        m_oChooseFile.SetDefaultExt(L"exe");
        m_oChooseFile.SetDefault(CFileNameModuleDir(GetDialog().Editbox(nId).GetText()).GetPureName());
        if (m_oChooseFile.ShowOpen()) {
            GetDialog().Editbox(nId).SetText(m_oChooseFile.GetResult().Get());
        }
    }
    void LoadFromConfig(CConfig& m_oConfig) {
        m_oConfig.FileData(L"ExViewer0File") >> CEditboxData(GetDialog(), IDC_EDIT1);
        m_oConfig.IndirectData(L"ExViewer0Arg") >> CEditboxData(GetDialog(), IDC_EDIT2);
        m_oConfig.IndirectData(L"ExViewer0Dir") >> CEditboxData(GetDialog(), IDC_EDIT3);
        m_oConfig.FileData(L"ExViewer1File") >> CEditboxData(GetDialog(), IDC_EDIT4);
        m_oConfig.IndirectData(L"ExViewer1Arg") >> CEditboxData(GetDialog(), IDC_EDIT5);
        m_oConfig.IndirectData(L"ExViewer1Dir") >> CEditboxData(GetDialog(), IDC_EDIT6);
        m_oConfig.FileData(L"ExViewer2File") >> CEditboxData(GetDialog(), IDC_EDIT7);
        m_oConfig.IndirectData(L"ExViewer2Arg") >> CEditboxData(GetDialog(), IDC_EDIT8);
        m_oConfig.IndirectData(L"ExViewer2Dir") >> CEditboxData(GetDialog(), IDC_EDIT9);

        UpdateCtrl();
    }
    void SaveToConfig(CConfig& m_oConfig) {
        m_oConfig.FileData(L"ExViewer0File") << CEditboxData(GetDialog(), IDC_EDIT1);
        m_oConfig.IndirectData(L"ExViewer0Arg") << CEditboxData(GetDialog(), IDC_EDIT2);
        m_oConfig.IndirectData(L"ExViewer0Dir") << CEditboxData(GetDialog(), IDC_EDIT3);
        m_oConfig.FileData(L"ExViewer1File") << CEditboxData(GetDialog(), IDC_EDIT4);
        m_oConfig.IndirectData(L"ExViewer1Arg") << CEditboxData(GetDialog(), IDC_EDIT5);
        m_oConfig.IndirectData(L"ExViewer1Dir") << CEditboxData(GetDialog(), IDC_EDIT6);
        m_oConfig.FileData(L"ExViewer2File") << CEditboxData(GetDialog(), IDC_EDIT7);
        m_oConfig.IndirectData(L"ExViewer2Arg") << CEditboxData(GetDialog(), IDC_EDIT8);
        m_oConfig.IndirectData(L"ExViewer2Dir") << CEditboxData(GetDialog(), IDC_EDIT9);
    }
    void UpdateCtrl() {
    }
};
