#pragma once

class CConfigDialogGUIPage : public CConfigDialogTabBase {
public:
    CConfigDialogGUIPage() : CConfigDialogTabBase(IDD_CFG_GUI) {}
private:
    CChooseColor m_oChooseColor;
    COLORREF m_rgbBgColor;
    bool HookMsg(CMsgHookPrms& rPrms) {
        if (rPrms.GetMsg() == WM_COMMAND) {
            UpdateCtrl();
            switch (rPrms.GetWPrmLoWord()) {
            case IDC_BUTTON1: //
                GetDialog().ShowPopupMenu(IDR_TITLEMENU);
                break;
            case ID_40270:  case ID_40271:  case ID_40272:  case ID_40273:
            case ID_40274:  case ID_40275:  case ID_40276:  case ID_40277:
            case ID_40278:  case ID_40279:  case ID_40281:  case ID_40282:
            case ID_40283:  case ID_40284:  case ID_40280:  case ID_MENUITEM40311:
            case ID_MENUITEM40314: case ID_MENUITEM40315:
                {
                    vector<string> vct = CResMenu(IDR_TITLEMENU).GetText(rPrms.GetWPrmLoWord()).Split(Array<string>(L"\t"));
                    if (vct.size() == 2) {
                        GetDialog().Editbox(IDC_EDIT1).SetFocus();
                        GetDialog().Editbox(IDC_EDIT1).InsertText(vct[0]);
                    }
                }
                break;
            default:
                return false;
            }
            return true;
        } else if (rPrms.GetMsg() == WM_INITDIALOG) {
            // [邿ՁB
            CDialogTooltip* pTip = new CDialogTooltip(GetDialog());
            pTip->Add(IDC_EDIT2, L"g勾̊g嗦𒷂̔Ŏw肵܂B\r\n"
                L"Ⴆ΁A200%Ȃc2{A50Ȃc1/2{ɂȂ܂B");
            pTip->Add(IDC_EDIT8, L"g勾̑傫w肵܂B( x c)");
            pTip->Add(IDC_EDIT9, L"g勾̑傫w肵܂B( x c)");
            pTip->Add(IDC_RADIO1, L"g勾̌`𒷕`ɂ܂B");
            pTip->Add(IDC_RADIO2, L"g勾̌`ȉ~`ɂ܂B\r\n"
                L"c̑傫ꍇ~`ɂȂ܂B");

            pTip->Add(IDC_CHECK5, L"J[\莞ԓȂJ[\\ɂ܂B");
            pTip->Add(IDC_EDIT27, L"J[\\ɂ܂ł̑҂Ԃw肵܂B");
            pTip->Add(IDC_CHECK3, L"̐ݒ肪IŁAPȏ̃tB^KpĂꍇAEBhE̍Ɂuev̕\悤ɂȂ܂B");
            pTip->Add(IDC_EDIT23, L"]̑傫sNZŎw肵܂B(㉺CE)\r\n"
                L"̒lwo܂B");
            pTip->Add(IDC_EDIT24, L"]̑傫sNZŎw肵܂B(㉺CE)\r\n"
                L"̒lwo܂B");
            pTip->Add(IDC_EDIT3, L"utXN[֐؂ւvsƂ̃fBXvC̉𑜓xw肵܂B( x c)");
            pTip->Add(IDC_EDIT4, L"utXN[֐؂ւvsƂ̃fBXvC̉𑜓xw肵܂B( x c)");
            pTip->Add(IDC_CHECK6, L"tXN[ESʕ\ɁÃEBhEANeBuɂȂꍇ̋w肵܂BIȂŏAItȂSʕ\ꎞIɉ܂B");
            pTip->Add(IDC_EDIT1, L"^Cgo[ɕ\镶̏ݒ肵܂B");
            pTip->Add(IDC_CHECK1, L"IɃEBhËʒuETCYۑANɕ܂B");
            pTip->Add(IDC_CHECK4, L"ENbNj[⑗Ȃǂt@Cǂݍ݂Nꍇ́AÕEBhËʒu𕜌܂B");
            pTip->Add(IDC_CHECK2, L"EBhEʒ[ɃXibv܂B");
            return true;
        } else if (rPrms.GetMsg() == WM_CLOSE) {
            GetDialog().Delete();
            return true;
        } else {
            return false;
        }
    }
    void LoadFromConfig(CConfig& m_oConfig) {
        m_oConfig.NumData(L"Magnification") >> CEditboxData(GetDialog(), IDC_EDIT2);
        ItoA(m_oConfig.Size(L"Magnifier").cx) >> CEditboxData(GetDialog(), IDC_EDIT8);
        ItoA(m_oConfig.Size(L"Magnifier").cy) >> CEditboxData(GetDialog(), IDC_EDIT9);
        m_oConfig.NumData(L"MagnifierShape") >> CRadiosData(GetDialog(), IDC_RADIO1, IDC_RADIO2);

        m_oConfig.BoolData(L"AutoCursorHide") >> CCheckboxData(GetDialog(), IDC_CHECK5);
        m_oConfig.NumData(L"AutoCursorHideTime") >> CEditboxData(GetDialog(), IDC_EDIT27);
        m_oConfig.BoolData(L"FilterMark") >> CCheckboxData(GetDialog(), IDC_CHECK3);
        m_oConfig.NumData(L"PaddingV") >> CEditboxData(GetDialog(), IDC_EDIT23);
        m_oConfig.NumData(L"PaddingH") >> CEditboxData(GetDialog(), IDC_EDIT24);
        ItoA(m_oConfig.Size(L"FullScreen").cx) >> CEditboxData(GetDialog(), IDC_EDIT3);
        ItoA(m_oConfig.Size(L"FullScreen").cy) >> CEditboxData(GetDialog(), IDC_EDIT4);
        m_oConfig.BoolData(L"FullScreenMinOnDeactive") >> CCheckboxData(GetDialog(), IDC_CHECK6);
        m_oConfig.IndirectData(L"Titlebar") >> CEditboxData(GetDialog(), IDC_EDIT1);
        m_oChooseColor.LoadFromString(m_oConfig.Str(L"ChooseColor"));

        m_oConfig.BoolData(L"WindowPosRestore") >> CCheckboxData(GetDialog(), IDC_CHECK1);
        m_oConfig.BoolData(L"WindowPosRestoreDisableOnLoad") >> CCheckboxData(GetDialog(), IDC_CHECK4);
        m_oConfig.BoolData(L"Snap") >> CCheckboxData(GetDialog(), IDC_CHECK2);

        UpdateCtrl();
    }
    void SaveToConfig(CConfig& m_oConfig) {
        m_oConfig.NumData(L"Magnification") << CEditboxData(GetDialog(), IDC_EDIT2);
        m_oConfig.SizeData(L"Magnifier") << CSize(
            GetDialog().Editbox(IDC_EDIT8).GetInt(),
            GetDialog().Editbox(IDC_EDIT9).GetInt());
        m_oConfig.NumData(L"MagnifierShape") << CRadiosData(GetDialog(), IDC_RADIO1, IDC_RADIO2);

        m_oConfig.BoolData(L"AutoCursorHide") << CCheckboxData(GetDialog(), IDC_CHECK5);
        m_oConfig.NumData(L"AutoCursorHideTime") << CEditboxData(GetDialog(), IDC_EDIT27);
        m_oConfig.BoolData(L"FilterMark") << CCheckboxData(GetDialog(), IDC_CHECK3);
        m_oConfig.NumData(L"PaddingV") << CEditboxData(GetDialog(), IDC_EDIT23);
        m_oConfig.NumData(L"PaddingH") << CEditboxData(GetDialog(), IDC_EDIT24);
        m_oConfig.SizeData(L"FullScreen") << CSize(
            GetDialog().Editbox(IDC_EDIT3).GetInt(),
            GetDialog().Editbox(IDC_EDIT4).GetInt());
        m_oConfig.BoolData(L"FullScreenMinOnDeactive") << CCheckboxData(GetDialog(), IDC_CHECK6);
        m_oConfig.IndirectData(L"Titlebar") << CEditboxData(GetDialog(), IDC_EDIT1);
        m_oConfig.Str(L"ChooseColor", m_oChooseColor.SaveToString());

        m_oConfig.BoolData(L"WindowPosRestore") << CCheckboxData(GetDialog(), IDC_CHECK1);
        m_oConfig.BoolData(L"WindowPosRestoreDisableOnLoad") << CCheckboxData(GetDialog(), IDC_CHECK4);
        m_oConfig.BoolData(L"Snap") << CCheckboxData(GetDialog(), IDC_CHECK2);
    }
    void UpdateCtrl() {
        CCtrlEnable(GetDialog().Checkbox(IDC_CHECK5).GetCheck())
            << GetDialog().GetCtrl(IDC_EDIT27);
        CCtrlEnable(GetDialog().Checkbox(IDC_CHECK1).GetCheck())
            << GetDialog().GetCtrl(IDC_CHECK4);
    }
};
