#pragma once
#include "SuffixUtility.h"

class CConfigDialogListPage : public CConfigDialogTabBase {
public:
    CConfigDialogListPage() : CConfigDialogTabBase(IDD_CFG_LIST) {}
private:
    bool HookMsg(CMsgHookPrms& rPrms) {
        if (rPrms.GetMsg() == WM_COMMAND) {
            UpdateCtrl();
            switch (rPrms.GetWPrmLoWord()) {
            case IDC_BUTTON1:   // ǉ{^
                GetDialog().Listbox(IDC_LIST1).Add(GetValidSuffix(GetDialog().Editbox(IDC_EDIT1).GetText()));
                GetDialog().Editbox(IDC_EDIT1).SetText(string());   //ۂɁB
                break;
            case IDC_BUTTON2:   // 폜{^
                GetDialog().Listbox(IDC_LIST1).Delete();
                break;
            case IDC_BUTTON3:   // ǉ{^
                GetDialog().Listbox(IDC_LIST2).Add(GetValidSuffix(GetDialog().Editbox(IDC_EDIT5).GetText()));
                GetDialog().Editbox(IDC_EDIT5).SetText(string());   //ۂɁB
                break;
            case IDC_BUTTON5:   // 폜{^
                GetDialog().Listbox(IDC_LIST2).Delete();
                break;
            default:
                return false;
            }
            return true;
        } else if (rPrms.GetMsg() == WM_INITDIALOG) {
            GetDialog().Combobox(IDC_COMBO1)
                .Add(L"R[h(ʏ)")
                .Add(L"啶ʖ")
                .Add(L"̫ޖ")
                .Add(L"̫ޖ/啶ʖ")
                .Add(L"t@CTCY")
                .Add(L"ŏIXV")
                .Add(L"l");

            // [邿ՁB
            CDialogTooltip* pTip = new CDialogTooltip(GetDialog());
            pTip->Add(IDC_CHECK4, L"Ƀt@CJĂԂŃt@CJƂAȈꍇ̓t@CXǧɒǉAIt̏ꍇ́ut@CSĕvsĂJƓɂȂ܂B");
            pTip->Add(IDC_CHECK12, L"t@CJۂɁAV[gJbgt@CꍇANHĊJ܂B");
            pTip->Add(IDC_CHECK2, L"ҏWj[́u``ƂďovsۂɁAot@Ct@CXg֒ǉ邩ǂݒ肵܂B");
            pTip->Add(IDC_RADIO1, L"݂̃t@C̎ɒǉ܂B");
            pTip->Add(IDC_RADIO2, L"t@CXg̈Ԍɒǉ܂B");
            pTip->Add(IDC_CHECK3, L"ut@CړvƁu}[Nt@Cړv̏ɁAړt@Ct@CXg폜܂B");
            pTip->Add(IDC_CHECK5, L"Ō̃t@C̎ֈړƐ擪̃t@CցA擪̃t@C̑OɈړƍŌ̃t@Cֈړ܂B\r\n"
                L"It̏ꍇ̏͌݉ŁAJ\ɐ擪̃t@CƍŌ̃t@C\ꂽA"
                L"擪▖̃t@Cǂݍ߂Ȃꍇɐ擪▖QԖڈȍ~̃t@C\ꂽ肷ꍇ܂B");
            pTip->Add(IDC_CHECK6, L"hbOhbvŃt@CJƂɁAt@CJ_CAOȂǂ̃JgfBNgAJt@ĈfBNgɕύX܂B");
            pTip->Add(IDC_CHECK10, L"IɂƁAJ\ɌJݒꍇɁAɂPy[Wi߁AEԂȂ獶AԂȂẺ摜\悤ɂ܂B\r\n"
                L"iPy[W\ŉ{AJ̃y[Wł̂݌J\gꍇȂǂɃIɂƕ֗܂B");

            pTip->Add(IDC_CHECK1, L"t@CJۂɁAȉ̊gqXg(ƃvOCݒɍ킹ĎIɍ\zXg)ɊYȂt@C𖳎܂B");
            pTip->Add(IDC_EDIT1, L"gqiu.vȂǂ͕tubmpv̂悤Ɂj͂܂B\r\n"
                L"ǉ{^ȂƔfȂ̂ŁAӂĂB");
            pTip->Add(IDC_EDIT5, L"gqiu.vȂǂ͕tubmpv̂悤Ɂj͂܂B\r\n"
                L"ǉ{^ȂƔfȂ̂ŁAӂĂB");
            pTip->Add(IDC_LIST1, L"ǂݍފgq̈ꗗB\r\n"
                L"ʓIȊgq́AvOCݒɍ킹ĎIɒǉ̂ŁAɒǉKv͂܂B");
            pTip->Add(IDC_LIST2, L"gq̈ꗗB\r\n"
                L"́ugq摜łɂłȂ疳v̐ݒ肪ItłLłB");

            pTip->Add(IDC_COMBO1, L"t@CXg̃ftHg̃\[gw肵܂B");

            pTip->Add(IDC_CHECK9, L"ɓ̃t@CۑہAftHg̃t@Cɏɂ̃t@C܂߂܂B");
            pTip->Add(IDC_CHECK22, L"ɓ̃t@CۑہAftHg̃t@Cɏɓ̃fBNg܂߂܂B");
            pTip->Add(IDC_EDIT3, L"Ƀt@CEfBNgEt@C̋؂Ɏgw肵܂B");

            pTip->Add(IDC_EDIT6, L"y[W莞́Ay[WsԊuA1/1000bPʂŎw肵܂B");
            pTip->Add(IDC_CHECK8, L"t@Ct@C폜ƁAt@C}[Nt@CSɍ폜ł́At@C̍폜GNXv[ɔC܂B");
            return true;
        } else if (rPrms.GetMsg() == WM_CLOSE) {
            GetDialog().Delete();
            return true;
        } else {
            return false;
        }
    }
    void ChooseDir(int nId) {
        CChooseDir oChooseDir;
        oChooseDir.SetOwner(GetDialog().GetHandle());
        oChooseDir.SetDefault(CFileNameModuleDir(GetDialog().Editbox(nId).GetText()));
        if (oChooseDir.Show()) {
            GetDialog().Editbox(nId).SetText(oChooseDir.GetResult().Get());
        }
    }
    void LoadFromConfig(CConfig& m_oConfig) {
        m_oConfig.BoolData(L"FileAddMode") >> CCheckboxData(GetDialog(), IDC_CHECK4);
        m_oConfig.BoolData(L"FileAddFollowLnk") >> CCheckboxData(GetDialog(), IDC_CHECK12);
        m_oConfig.BoolData(L"FileAddWithSave") >> CCheckboxData(GetDialog(), IDC_CHECK2);
        m_oConfig.BoolData(L"FileAddWithSaveNext") >> CCheckboxData(GetDialog(), IDC_RADIO1);
        !m_oConfig.Bool(L"FileAddWithSaveNext") >> CCheckboxData(GetDialog(), IDC_RADIO2);
        m_oConfig.BoolData(L"RemoveOnMove") >> CCheckboxData(GetDialog(), IDC_CHECK3);
        m_oConfig.BoolData(L"LinkFirstAndLast") >> CCheckboxData(GetDialog(), IDC_CHECK5);
        m_oConfig.BoolData(L"CDOnDrop") >> CCheckboxData(GetDialog(), IDC_CHECK6);
        m_oConfig.BoolData(L"NextOnCancelSpread") >> CCheckboxData(GetDialog(), IDC_CHECK10);

        m_oConfig.BoolData(L"IgnoreBySuffix") >> CCheckboxData(GetDialog(), IDC_CHECK1);
        m_oConfig.StrData(L"IgnoreExcludeSuffixes") >> SuffixListData(GetDialog(), IDC_LIST1);
        m_oConfig.StrData(L"IgnoreSuffixes") >> SuffixListData(GetDialog(), IDC_LIST2);

        m_oConfig.NumData(L"SortMode") >> CComboboxData(GetDialog(), IDC_COMBO1);

        m_oConfig.BoolData(L"SaveNameUseArchive") >> CCheckboxData(GetDialog(), IDC_CHECK9);
        m_oConfig.BoolData(L"SaveNameUseArchiveDir") >> CCheckboxData(GetDialog(), IDC_CHECK22);
        m_oConfig.StrData(L"SaveNameSeparator") >> CEditboxData(GetDialog(), IDC_EDIT3);

        m_oConfig.NumData(L"SlideShowFreq") >> CEditboxData(GetDialog(), IDC_EDIT6);
        m_oConfig.BoolData(L"DeleteByShell") >> CCheckboxData(GetDialog(), IDC_CHECK8);

        UpdateCtrl();
    }
    void SaveToConfig(CConfig& m_oConfig) {
        m_oConfig.BoolData(L"FileAddMode") << CCheckboxData(GetDialog(), IDC_CHECK4);
        m_oConfig.BoolData(L"FileAddFollowLnk") << CCheckboxData(GetDialog(), IDC_CHECK12);
        m_oConfig.BoolData(L"FileAddWithSave") << CCheckboxData(GetDialog(), IDC_CHECK2);
        m_oConfig.BoolData(L"FileAddWithSaveNext") << CCheckboxData(GetDialog(), IDC_RADIO1);
        m_oConfig.BoolData(L"RemoveOnMove") << CCheckboxData(GetDialog(), IDC_CHECK3);
        m_oConfig.BoolData(L"LinkFirstAndLast") << CCheckboxData(GetDialog(), IDC_CHECK5);
        m_oConfig.BoolData(L"CDOnDrop") << CCheckboxData(GetDialog(), IDC_CHECK6);
        m_oConfig.BoolData(L"NextOnCancelSpread") << CCheckboxData(GetDialog(), IDC_CHECK10);

        m_oConfig.BoolData(L"IgnoreBySuffix") << CCheckboxData(GetDialog(), IDC_CHECK1);
        m_oConfig.StrData(L"IgnoreExcludeSuffixes") << SuffixListData(GetDialog(), IDC_LIST1);
        m_oConfig.StrData(L"IgnoreSuffixes") << SuffixListData(GetDialog(), IDC_LIST2);

        m_oConfig.NumData(L"SortMode") << CComboboxData(GetDialog(), IDC_COMBO1);

        m_oConfig.BoolData(L"SaveNameUseArchive") << CCheckboxData(GetDialog(), IDC_CHECK9);
        m_oConfig.BoolData(L"SaveNameUseArchiveDir") << CCheckboxData(GetDialog(), IDC_CHECK22);
        m_oConfig.StrData(L"SaveNameSeparator") << CEditboxData(GetDialog(), IDC_EDIT3);

        m_oConfig.NumData(L"SlideShowFreq") << CEditboxData(GetDialog(), IDC_EDIT6);
        m_oConfig.BoolData(L"DeleteByShell") << CCheckboxData(GetDialog(), IDC_CHECK8);
    }
    void UpdateCtrl() {
        // ot@C̒ǉ
        CCtrlEnable(GetDialog().Checkbox(IDC_CHECK2).GetCheck())
            << GetDialog().GetCtrl(IDC_RADIO1)
            << GetDialog().GetCtrl(IDC_RADIO2)
            ;
        // ǂݍފgq
        CCtrlEnable(GetDialog().Checkbox(IDC_CHECK1).GetCheck())
            << GetDialog().GetCtrl(IDC_EDIT1)
            << GetDialog().GetCtrl(IDC_LIST1)
            << GetDialog().GetCtrl(IDC_BUTTON1)
            << GetDialog().GetCtrl(IDC_BUTTON2)
            ;
        // ςꂽ
        CCtrlEnable(GetDialog().Checkbox(IDC_CHECK9).GetCheck() || GetDialog().Checkbox(IDC_CHECK22).GetCheck())
            << GetDialog().GetCtrl(IDC_EDIT3)
            ;
    }
};
