#pragma once
#include <Themis/Archive.h>

class CConfigDialogPluginPage : public CConfigDialogTabBase {
public:
    CConfigDialogPluginPage(CSpi& r) : CConfigDialogTabBase(IDD_CFG_PLG), m_rSpi(r) {
        susieDir = CSpi::GetInstallDir();
    }
private:
    bool HookMsg(CMsgHookPrms& rPrms) {
        if (rPrms.GetMsg() == WM_COMMAND) {
            UpdateCtrl();
            switch (rPrms.GetWPrmLoWord()) {
            case IDC_LIST1:
                if (rPrms.GetWPrmHiWord() == LBN_DBLCLK) {
                    if (GetDialog().Button(IDC_BUTTON3).IsEnabled()) {
                        GetDialog().SendMsg(WM_COMMAND, IDC_BUTTON3, 0);
                        //ɁFݒ{^
                    }
                }
                break;
            case IDC_LIST3:
                if (rPrms.GetWPrmHiWord() == LBN_DBLCLK) {
                    if (GetDialog().Button(IDC_BUTTON9).IsEnabled()) {
                        GetDialog().SendMsg(WM_COMMAND, IDC_BUTTON9, 0);
                        //SPIFݒ{^
                    }
                }
                break;
            case IDC_BUTTON1:{  //ɁF
                CListbox oList1 = GetDialog().GetCtrl(IDC_LIST1);
                int nPos = oList1.GetSelected();
                if (0 < nPos) {
                    string str = oList1.Get();
                    oList1.Delete(nPos);
                    oList1.Insert(nPos - 1, str);
                    oList1.SetSelected(nPos - 1);
                }
                }break;
            case IDC_BUTTON2:{  //ɁF
                CListbox oList1 = GetDialog().GetCtrl(IDC_LIST1);
                int nPos = oList1.GetSelected();
                if (nPos < oList1.GetCount() - 1) {
                    string str = oList1.Get();
                    oList1.Delete(nPos);
                    oList1.Insert(nPos + 1, str);
                    oList1.SetSelected(nPos + 1);
                }
                }break;
            case IDC_BUTTON5:{  //摜F
                CListbox oList2 = GetDialog().GetCtrl(IDC_LIST2);
                int nPos = oList2.GetSelected();
                if (0 < nPos) {
                    string str = oList2.Get();
                    oList2.Delete(nPos);
                    oList2.Insert(nPos - 1, str);
                    oList2.SetSelected(nPos - 1);
                }
                }break;
            case IDC_BUTTON7:{  //摜F
                CListbox oList2 = GetDialog().GetCtrl(IDC_LIST2);
                int nPos = oList2.GetSelected();
                if (nPos < oList2.GetCount() - 1) {
                    string str = oList2.Get();
                    oList2.Delete(nPos);
                    oList2.Insert(nPos + 1, str);
                    oList2.SetSelected(nPos + 1);
                }
                }break;
            case IDC_BUTTON3:{  //ɁFݒ{^
                CListbox oList1 = GetDialog().GetCtrl(IDC_LIST1);
                string strArchiverDll = oList1.Get();
                if (strArchiverDll == L"UNZIP32.DLL") {
                    CUnZipArchiver().ConfigDialog(rPrms.GetWnd());
                } else if (strArchiverDll == L"7-ZIP32.DLL") {
                    C7ZipArchiver().ConfigDialog(rPrms.GetWnd());
                } else if(strArchiverDll == L"UNRAR32.DLL") {
                    CUnRarArchiver().ConfigDialog(rPrms.GetWnd());
                } else if (strArchiverDll == L"UNLHA32.DLL") {
                    CUnLhaArchiver().ConfigDialog(rPrms.GetWnd());
                } else if (strArchiverDll == L"UNGCA32.DLL") {
                    CUnGcaArchiver().ConfigDialog(rPrms.GetWnd());
                }
                }break;
            case IDC_BUTTON10:{ //SPIF{^
                CListbox oList3 = GetDialog().GetCtrl(IDC_LIST3);
                m_oCfgList[oList3.Get()](rPrms.GetWnd(), SPI::CONFIGDLG_ABOUT);
                }break;
            case IDC_BUTTON9:{  //SPIFݒ{^
                CListbox oList3 = GetDialog().GetCtrl(IDC_LIST3);
                m_oCfgList[oList3.Get()](rPrms.GetWnd(), SPI::CONFIGDLG_SETTING);
                }break;
            case IDC_BUTTON12: //pX[hFǉ{^
                GetDialog().Listbox(IDC_LIST4).Add(GetDialog().Editbox(IDC_EDIT1).GetText());
                GetDialog().Editbox(IDC_EDIT1).SetText(string());
                break;
            case IDC_BUTTON13: //pX[hF폜{^
                GetDialog().Listbox(IDC_LIST4).Delete();
                break;
            case IDC_BUTTON8: ChooseDir(IDC_EDIT26); break;
            case IDC_BUTTON11: ChooseDir(IDC_EDIT10); break;
            case IDC_BUTTON6: // susie{^
                GetDialog().Editbox(IDC_EDIT10).SetText(susieDir);
                break;
            default:
                return false;
            }
            return true;
        } else if (rPrms.GetMsg() == WM_INITDIALOG) {
            // [邿ՁB
            CDialogTooltip* pTip = new CDialogTooltip(GetDialog());
            pTip->Add(IDC_LIST1, L"eDLLSusievOCgpǂݍ݂Ȃǂ̗D揇ʂƎgpEsgpݒ肵܂B\r\n"
                L"\r\n"
                L" O(ZIP/zlib)\r\n"
                L" тɓĂZIPǂݍ݂gp܂Bǂݍރwb_̈ႢCRC̃`FbNȂǂsĂȂ֌WŁAjZIPt@Cǂݍ߂ꍇ܂B\r\n"
             // L"\r\n"
             // L" O(GCA/GCASDK)\r\n"
             // L" тɓĂGCAǂݍ݂gp܂B\r\n"
                L"\r\n"
                L" SusievOC\r\n"
                L"SusievOCiaxzip.spiȂǁjpďɂ̓ǂݍ݂s܂B\r\n"
                L"\r\n"
             // L" UNZIP32.DLLAUNLHA32.DLLAUNRAR32.DLLA7-zip32.DLL\r\n"
                L" UNZIP32.DLLAUNLHA32.DLLAUNRAR32.DLLA7-zip32.DLLAUNGCA32.DLL\r\n"
                L"ꂼ̃A[JCo[DLLpēǂݍ݂܂B\r\n");
            pTip->Add(IDC_BUTTON1, L"Iꂽǂݍݕ@̗D揇ʂグ܂B");
            pTip->Add(IDC_BUTTON2, L"Iꂽǂݍݕ@̗D揇ʂ܂B");
            pTip->Add(IDC_BUTTON3, L"Iꂽǂݍݕ@̐ݒs܂B");

            pTip->Add(IDC_LIST2, L"ɂƓlɁASusievOC⎩Oł̊et@C̓ǂݍ݁Aꂼ̗D揇ʂƎgpEsgpݒ肵܂B\r\n"
                L"\r\n"
                L" O(JPG/IJG)Ȃ\r\n"
                L" тɓĂe摜̓ǂݍݏgp܂Bʂ̒́AXbV̑Oǂݍތ`A낪gp@(CuȂ)łB\r\n"
                L" BMP͊ȒPȌ`͊SɎOœǂݍ݂܂Aꕔ̌`łGDIēǂݍ݂܂B̏ꍇA摜̐Fʂ̐FɏɕϊĂ܂ꍇ܂B24rbgJ[菭ȂF̏ꍇAҏWĕۑ鎞Ȃǂ͒ӂĂB\r\n"
                L"\r\n"
                L" O(ICOȂ/OLE)\r\n"
                L" BMP̓ǂݍ݂ƓlɁAʂ̐FɈˑ܂B܂IEOfficeȂǂ̃CXg[󋵂ɂĔɓ삪A摜t@Cj摜t@CǂݍƂꍇ̋sȂ悤łBݒł͎gpȂݒɂĂ܂B\r\n"
                L"\r\n"
                L" SusievOC\r\n"
                L" 摜ǂݍ Susie vOCgpēǂݍ݂s܂B");
            pTip->Add(IDC_BUTTON5, L"Iꂽǂݍݕ@̗D揇ʂグ܂B");
            pTip->Add(IDC_BUTTON7, L"Iꂽǂݍݕ@̗D揇ʂ܂B");

            pTip->Add(IDC_LIST3, L"ǂݍ܂ĂSusievOC̈ꗗ̊mFƁAݒ_CAO̕\s܂B");
            pTip->Add(IDC_BUTTON10, L"o[W_CAO\܂B");
            pTip->Add(IDC_BUTTON9, L"ݒ_CAO\܂B");

            pTip->Add(IDC_EDIT26, L"ɂ𓀂ꍇ̉𓀐tH_w肵܂B");
            pTip->Add(IDC_BUTTON8, L"tH_I܂B");
            pTip->Add(IDC_EDIT10, L"SPÎtH_w肵܂B");
            pTip->Add(IDC_BUTTON11, L"tH_I܂B");
            pTip->Add(IDC_BUTTON6, L"SusieCXg[Ăꍇ̃CXg[ݒ肵܂B");

            pTip->Add(IDC_EDIT1, L"pX[h͂Aǉ{^ăXgɒǉ܂B");
            pTip->Add(IDC_LIST4, L"pX[htɂ̓ǂݍݎɁAIɎspX[h̃XgB\r\n݂͎OZIPǂݍ݂ł̂ݗLłB");
            pTip->Add(IDC_BUTTON12, L"pX[hǉ܂B");
            pTip->Add(IDC_BUTTON13, L"IĂpX[h폜܂B");
            return true;
        } else if (rPrms.GetMsg() == WM_CLOSE) {
            GetDialog().Delete();
            return true;
        } else {
            return false;
        }
    }
    void ChooseDir(int nId) {
        CChooseDir oChooseDir;
        oChooseDir.SetOwner(GetDialog().GetHandle());
        oChooseDir.SetDefault(CFileNameModuleDir(GetDialog().Editbox(nId).GetText()));
        if (oChooseDir.Show()) {
            GetDialog().Editbox(nId).SetText(oChooseDir.GetResult().Get());
        }
    }
    void LoadFromConfig(CConfig& m_oConfig) {
        CListbox oList1 = GetDialog().GetCtrl(IDC_LIST1);
        CListbox oList2 = GetDialog().GetCtrl(IDC_LIST2);
        CListbox oList3 = GetDialog().GetCtrl(IDC_LIST3);

        // ɓǂݍ݃Xg
        typedef PriorityObject<int> PO;
        std::multiset<PO> al;
        al.insert(PO(new int(0), m_oConfig.Num(L"ArchiverPriorityX")));
        al.insert(PO(new int(1), m_oConfig.Num(L"ArchiverPriorityZ")));
        al.insert(PO(new int(2), m_oConfig.Num(L"ArchiverPriorityR")));
        al.insert(PO(new int(3), m_oConfig.Num(L"ArchiverPriorityL")));
        al.insert(PO(new int(4), m_oConfig.Num(L"ArchiverPriorityS")));
        al.insert(PO(new int(5), m_oConfig.Num(L"ArchiverPriorityZL")));
        al.insert(PO(new int(6), m_oConfig.Num(L"ArchiverPriority7Z")));
        al.insert(PO(new int(7), m_oConfig.Num(L"ArchiverPriorityG")));
        oList1.Clear();
        {
            const string ap[] = {
                L"--------------------",
                L"UNZIP32.DLL",
                L"UNRAR32.DLL",
                L"UNLHA32.DLL",
                L"SusievOC",
                L"O(ZIP/zlib)",
                L"7-ZIP32.DLL",
                L"UNGCA32.DLL",
             // L"O(GCA/GCASDK)",
            };
            for (std::multiset<PO>::iterator it = al.begin(); it != al.end(); ++it) {
                oList1.Add(ap[**it]);
            }
        }

        // 摜ǂݍ݃Xg
        std::multiset<PO> il;
        il.insert(PO(new int(0), m_oConfig.Num(L"LoaderPriorityX")));
        il.insert(PO(new int(1), m_oConfig.Num(L"LoaderPriorityJ")));
        il.insert(PO(new int(2), m_oConfig.Num(L"LoaderPriorityP")));
        il.insert(PO(new int(3), m_oConfig.Num(L"LoaderPriorityB")));
        il.insert(PO(new int(4), m_oConfig.Num(L"LoaderPriorityO")));
        il.insert(PO(new int(5), m_oConfig.Num(L"LoaderPriorityA")));
        il.insert(PO(new int(6), m_oConfig.Num(L"LoaderPriorityS")));
        il.insert(PO(new int(7), m_oConfig.Num(L"LoaderPriorityT")));
        oList2.Clear();
        {
            const string ip[] = {
                L"--------------------",
                L"O(JPG/IJG)",
                L"O(PNG/libpng)",
                L"O(BMP/GDI)",
                L"O(ICOȂ/OLE)",
                L"O(ARGB)",
                L"SusievOC",
                L"O(TGA)",
            };
            for (std::multiset<PO>::iterator it = il.begin(); it != il.end(); ++it) {
                oList2.Add(ip[**it]);
            }
        }

        // SPIXg
        m_oCfgList.clear();
        for (int i = 0, n = m_rSpi.GetCount(); i < n; i++) {
            string strName = m_rSpi.GetName(i);
            try {
                m_oCfgList.insert(std::make_pair(strName, m_rSpi.ConfigurationDlg(i)));
            } catch (std::exception&) {
                m_oCfgList.insert(std::make_pair(strName, SPI::ConfigurationDlg(NULL)));
            }
            oList3.Add(strName);
        }

        oList1.SetSelected(0);
        oList2.SetSelected(0);
        oList3.SetSelected(0);

        string str;
        m_oConfig.StrData(L"ArcPassAutoTry") >> str;
        GetDialog().Listbox(IDC_LIST4).Clear().Add(str.Split(Array<string>(L"\n")));

        m_oConfig.FileData(L"SpiPluginsDir") >> CEditboxData(GetDialog(), IDC_EDIT10);
        m_oConfig.FileData(L"TmpDir") >> CEditboxData(GetDialog(), IDC_EDIT26);

        UpdateCtrl();
    }
    void SaveToConfig(CConfig& m_oConfig) {
        CListbox oList1 = GetDialog().GetCtrl(IDC_LIST1);
        CListbox oList2 = GetDialog().GetCtrl(IDC_LIST2);
        CListbox oList3 = GetDialog().GetCtrl(IDC_LIST3);
        const string ap[] = {
            L"--------------------",
            L"UNZIP32.DLL",
            L"UNRAR32.DLL",
            L"UNLHA32.DLL",
            L"SusievOC",
            L"O(ZIP/zlib)",
            L"7-ZIP32.DLL",
            L"UNGCA32.DLL",
         // L"O(GCA/GCASDK)",
        };
        for (int i = 0, n = oList1.GetCount(); i < n; i++) {
            int nIndex = static_cast<int>(std::find(ap, ap + (sizeof(ap)/sizeof(*ap)), oList1.Get(i)) - ap);
            switch (nIndex) {
            case 0: m_oConfig.Num(L"ArchiverPriorityX", i * 4); break;
            case 1: m_oConfig.Num(L"ArchiverPriorityZ", i * 4); break;
            case 2: m_oConfig.Num(L"ArchiverPriorityR", i * 4); break;
            case 3: m_oConfig.Num(L"ArchiverPriorityL", i * 4); break;
            case 4: m_oConfig.Num(L"ArchiverPriorityS", i * 4); break;
            case 5: m_oConfig.Num(L"ArchiverPriorityZL", i * 4); break;
            case 6: m_oConfig.Num(L"ArchiverPriority7Z", i * 4); break;
            case 7: m_oConfig.Num(L"ArchiverPriorityG", i * 4); break;
            default:
                throw RuntimeException(L"ɓǂݍݐݒ̕ۑɃG[܂");
            }
        }
        const string ip[] = {
            L"--------------------",
            L"O(JPG/IJG)",
            L"O(PNG/libpng)",
            L"O(BMP/GDI)",
            L"O(ICOȂ/OLE)",
            L"O(ARGB)",
            L"SusievOC",
            L"O(TGA)",
        };
        for (int i = 0, n = oList2.GetCount(); i < n; i++) {
            int nIndex = static_cast<int>(std::find(ip, ip + (sizeof(ip)/sizeof(*ip)), oList2.Get(i)) - ip);
            switch (nIndex) {
            case 0: m_oConfig.Num(L"LoaderPriorityX", i * 4); break;
            case 1: m_oConfig.Num(L"LoaderPriorityJ", i * 4); break;
            case 2: m_oConfig.Num(L"LoaderPriorityP", i * 4); break;
            case 3: m_oConfig.Num(L"LoaderPriorityB", i * 4); break;
            case 4: m_oConfig.Num(L"LoaderPriorityO", i * 4); break;
            case 5: m_oConfig.Num(L"LoaderPriorityA", i * 4); break;
            case 6: m_oConfig.Num(L"LoaderPriorityS", i * 4); break;
            case 7: m_oConfig.Num(L"LoaderPriorityT", i * 4); break;
            default:
                throw RuntimeException(L"摜ǂݍݐݒ̕ۑɃG[܂");
            }
        }

        m_oConfig.StrData(L"ArcPassAutoTry") <<
            string::Join(L"\n", GetDialog().Listbox(IDC_LIST4).GetAll());

        m_oConfig.FileData(L"SpiPluginsDir") << CEditboxData(GetDialog(), IDC_EDIT10);
        m_oConfig.FileData(L"TmpDir") << CEditboxData(GetDialog(), IDC_EDIT26);
    }
    void UpdateCtrl() {
        CListbox oList1 = GetDialog().GetCtrl(IDC_LIST1);
        CListbox oList2 = GetDialog().GetCtrl(IDC_LIST2);
        CListbox oList3 = GetDialog().GetCtrl(IDC_LIST3);

        string strArchiverDll = oList1.Get();
        if (strArchiverDll == L"UNZIP32.DLL" ||
            strArchiverDll == L"7-ZIP32.DLL" ||
            strArchiverDll == L"UNRAR32.DLL" ||
            strArchiverDll == L"UNLHA32.DLL" ||
            strArchiverDll == L"UNGCA32.DLL") {
            GetDialog().Button(IDC_BUTTON3).SetEnable(true);
        } else {
            GetDialog().Button(IDC_BUTTON3).SetEnable(false);
        }

        std::map<string, SPI::ConfigurationDlg>::iterator it = m_oCfgList.find(oList3.Get());
        GetDialog().Button(IDC_BUTTON10).SetEnable(it != m_oCfgList.end() && it->second != NULL);
        GetDialog().Button(IDC_BUTTON9).SetEnable(it != m_oCfgList.end() && it->second != NULL);

        //susie{^
        GetDialog().Button(IDC_BUTTON6).SetEnable(!string::IsNullOrEmpty(susieDir));
    }

    CSpi& m_rSpi;
    string susieDir;
    std::map<string, SPI::ConfigurationDlg> m_oCfgList;
};
